/* extmain.skel include file for extraction
 * $Log: extmain.skel,v $
 * Revision 1.19  1999/11/18 19:30:33  nort
 * Added <math.h> for floor() as generated for conversions
 *
 * Revision 1.18  1995/10/18  02:05:48  nort
 * Changes to nlcon_display()
 *
 * Revision 1.17  1995/10/06  16:40:02  nort
 * Changes to nlcon_disp()
 * Old change to ROWS() and FRACSECS() macros
 *
 * Revision 1.16  1994/08/29  20:29:28  nort
 * Changes for OUI
 *
 * Revision 1.15  1993/09/27  18:55:31  nort
 * Cleaned up RCS log
 * Cleaned up rcsid[] with Watcom pragmas
 * Added #include <string.h> for memcpy prototype.
 *
 * Revision 1.14  1993/05/19  19:04:51  nort
 * Changed OPT_CON_INIT to OPT_CONSOLE_INIT to allow judicious
 * redefinition for TMA.
 */
#include <stdio.h>
#include <string.h>
#include <sys/kernel.h>
#include <unistd.h>
#include <math.h>
#include "oui.h"
#include "dbr.h"
#include "globmsg.h"
#include "msg.h"
#pragma off (unreferenced)
  static char emrcsid[] =
	"$Id: extmain.skel,v 1.19 1999/11/18 19:30:33 nort Exp nort $";
#pragma on (unreferenced)



 typedef unsigned short UINT;


 typedef unsigned char UCHAR;
	unsigned short InjectingInc = 0;


 typedef unsigned long ULONG;
ULONG CHROMtime;
#include "convfunc.h"
#include "ttdriver.h"
#include "defcals.h"

int tt_p4=72;
int tt_p3=48;
int tt_p2=24;
int tt_p1=0;




	
	

	 typedef float adT;
	 typedef float adT_flow;
	 typedef float vdc_chan;
	 typedef float vdc_pow;
	 typedef float adT_pump;

	 typedef float dacMSpr;

	 typedef UINT InjStateT;

float read_atod(int atod_chan) {
	
	unsigned short atod_val;
	float voltage = -99999;

	atod_val = tt_read_atod( atod_chan );
	atod_val = atod_val + 2048;
	atod_val = atod_val & 0xFFF;

	if (atod_val >= 2048)	{
		atod_val = atod_val|(0xF000);
		atod_val=~atod_val;
		++atod_val;
		voltage = -10.0 * ((float) atod_val) / 2048.0;
		//	printf("reading atod channel %i value is negative %i \n",atod_chan, atod_val);
	} else 	{
		voltage = 10.0 * ((float) atod_val) / 2048.0;
	//	printf("reading atod channel %i value is %f \n",atod_chan,voltage);

	}	

	return voltage;
}


float read_temp(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps(voltage);
}


float read_temp12v(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps12v(voltage);
}

float read_ad_value(int address, float R1, float V1, float V0) { 
	float Vx;

	Vx = read_atod(address);

	if (Vx < 0)
		Vx = -Vx;

	return convert_VtoR( Vx, R1, V1, V0 );

}



#include "valves.h"
#include "address.h"





	 typedef unsigned char DigOutWd;
	 typedef DigOutWd DigInWd;



	 typedef short DigBit;
	 typedef DigBit Bit_HI_LO;
	 typedef DigBit Bit_Op_Cl;
	 typedef DigBit Bit_Cl_Op;
	 typedef DigBit Bit_On_Off;
	 typedef DigBit Bit_Off_On;
	 typedef DigBit Bit_Air_Cal;
	 typedef DigBit Bit_offline;


	UCHAR MSDstateS;

int read_dig_in (unsigned short dig_chan)  {
	
	unsigned short dig_val;
	unsigned short address;
	int value;

	address=dig_chan/8;	
	dig_val=tt_read_digital(address);
	address=dig_chan-address*8;
	value=1<<address;
	//	address=pow(2,address);
	dig_val=dig_val&value;
	if (dig_val==0)
		return 0;
	return 1;
}

int read_dig_out(int chan) {

	return read_dig_in(chan+64);
}


int fail_board(int digch) {
	static int fail_toggle = 0;
	
	if (fail_toggle==0) {
		tt_scdc_command(100 + digch);
		fail_toggle = 1;
		return fail_toggle;
	}

	fail_toggle = 0;
	tt_scdc_command(digch);
	return fail_toggle;
}

// used to pulse a digch (hard coded for dig 20 and 21
// and MSDstate 4 and 5).
int trapToggle( int digch ) {
	static int pulse1 = 0;
	static int pulse2 = 0;
	int	pulse, state;
	const int trap1add = 20;
	const int trap2add = 21;

	if (digch == trap1add) {
	 	state = 4;
		pulse = pulse1;
	} else if (digch == trap2add) {
		state = 5;
		pulse = pulse2;
	} else {
		return 0;
	}

	// toggle dig line
	if ( MSDstateS == state ) {
		switch ( pulse ) {
			case 0:		// off, turn on
				tt_scdc_command( 100 + digch );
				pulse = 1;
				break;
			case 1:		// on, turn off
				tt_scdc_command( digch );
				pulse = 0;
				break;
		}
	} else {
		if ( pulse == 1 ) {
			tt_scdc_command( digch );
			pulse = 0;
		}
	}

	if (digch == trap1add)
		pulse1 = pulse;
	else
		pulse2 = pulse;

	return read_dig_out( digch );

}


#include <sys/types.h>
pid_t rs485_proxy;
short Omega485[34];

short OmegaArray( int add ) {
	return Omega485[add];
}



 typedef short OmegaT;

 typedef short OmegaTsp;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include "/home/panther/drivers/smart/smart.h"
#include "regnames.h"
#include "panthermsg.h"

#define 		ECDOFFLINE 		-9999
#define			NUMSECSXAXIS	 150
#define			ELECRATE		0.1			// seconds

pid_t			ECDresp_proxy;

chrom_packet 	ECDresp[MAXDET];

long int 		DetAvgCt1=0, DetAvgCt2=0, DetAvgCt3=0, DetAvgCt4=0,
		 		DetAvgOffline1=0, DetAvgOffline2=0, DetAvgOffline3=0, DetAvgOffline4=0,
	 			ecd_sum1=0, ecd_sum2=0, ecd_sum3=0, ecd_sum4=0,
				ecdA_SF6save=0, ecdA_F11save=0, ecdA_COsave=0, ecdA_PANsave=0;
float			ecdSF6x = 0.0, ecdF11x = 0.0, ecdCOx = 0.0, ecdPANx = 0.0;
int				currPoint[MAXDET];

// function gets the data from shared data array with smart driver
long int GC_Ctr_Pull( int elecADD ) {
	long ecdDATA;
	
	if ( currPoint[elecADD] >= MAXPOINTS ) currPoint[elecADD] = 0;

	// new data
	if ( currPoint[elecADD] < ECDresp[elecADD].numpnts ) {
		ecdDATA = ECDresp[elecADD].resp[currPoint[elecADD]];
		currPoint[elecADD]++;
	} 
	else {
		ecdDATA = ECDOFFLINE;
		currPoint[elecADD] = 0;
		ECDresp[elecADD].numpnts = -1;
	}

	return ecdDATA;	
}




 typedef long GC_Freq;
 typedef long GC_Ctr;

GC_Freq ecdA_SF6, ecdA_F11, ecdA_CO, ecdA_PAN;

 typedef unsigned char UNYBL;


 typedef unsigned long InjFile;

InjFile ITXFileNum;




ULONG CUMSEC;
#include <sys/types.h>
pid_t valco_proxy;
int valvePos[10] = {0,0,3,3,3,3,3,3,3,3};


 typedef short valvT;
 typedef DigBit valvetext;
 typedef DigBit valveMS1text;
 typedef DigBit valveMS2text;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "da_cache.h"
#include "regnames.h"

#define MAXMSDCHANS 	  8		// Max number of MS channels
#define MAXMSDIONS 		 30		// Max number of ions per channel
#define MAXMSDPOINTS 	 30		// Max Number of data points in a second for an ion
#define MSDOFFLINE 	  -9999
#define MSDMISSING	   -999
#define MAXSENDMSG     2000		// max number of chars from the msd server
#define SEPCHARS		":,()"
#define MSDIONFILE		"/home/panther/flight/msd.ions"

pid_t		MSDresp_proxy;

long int 	MSD_Data_Array[MAXMSDCHANS][MAXMSDPOINTS],
			MSD_Time_Array[MAXMSDPOINTS],
			msdTIMEoldPlot,
			MSchanAvg[MAXMSDCHANS],
			msd_sum[MAXMSDCHANS],
			MSD_ChanX;

unsigned int 	currMSDPoint[MAXMSDCHANS],
				chanInc;

unsigned char 	MSDresp[MAXSENDMSG];		// data returned by msd

struct MSwindow {
	float	ion;			// ion number
	float	dwell;			// dwell time (0 < dwell <= 1) (fraction of a second)
} MStable[MAXMSDCHANS][MAXMSDIONS];


int ReadMSDionFile ( char *IONFILE ) {
	FILE 	*fp;
	char 	buffer[1000];
	char 	*p;
	char	tmp[1];
	int		chan, inc;
	static char	once;
	double	ion, dwell;

	if (once == 1) return 0;

	fp = fopen(	IONFILE, "r" );
	if (fp == NULL) {
		fprintf(stderr, "Open failed: Cannont find %s\n", IONFILE);
		return -1;
	} else {
		while ( fgets( buffer, 1000, fp ) != NULL ) {

			// First strip out the MS channel number
			p = strstr( strlwr(buffer), "mschan" );
			strncpy(tmp, p + strlen("MSchan"), 1);
			chan = atoi(tmp);
			if (chan >= MAXMSDCHANS)
				break;
		
			// Next strip out the ions and dwell times
			p =	strtok(buffer, SEPCHARS );
			inc = 0;
			while ( p != NULL ) {

				if ( strstr(strlwr(p), "null") != NULL ) {
					MStable[chan][inc].ion = 0;
					MStable[chan][inc].dwell = 0;
					inc++;
				} else {
					ion = atof(p);
					if (ion >= 1) { 		// found ion
						p = strtok( NULL, SEPCHARS );
						dwell = atof(p);
						if (( dwell <= 1 ) && ( dwell > 0 )) {
							MStable[chan][inc].ion = ion;
							MStable[chan][inc].dwell = dwell;
							//printf ("%d,%d: %f %f\n", chan, inc, ion, dwell);
						} else {
							MStable[chan][inc].ion = 0;
							MStable[chan][inc].dwell = 0;
							fprintf(stderr, "Bad dwell time for channel %d, ion %f\n", chan, ion);
						}

						inc++;
					} else {
						MStable[chan][inc].ion = 0;
						MStable[chan][inc].dwell = 0;
						//printf("null ion: chan = %d, inc = %d\n", chan,inc);
					}

				}

				p = strtok( NULL, SEPCHARS );
			}
		}
	}

	fclose(fp);
	once = 1;

	return 0;

}

// Function takes a ion number and returns the MS channel number for
// a given time window.
int ion2chan( int win, float ion ) {

	int ch;
	float tol = 0.001;

	// Out of range variable
	if (win > MAXMSDIONS)
		return -1;

	// Scan MStable array for match
	for(ch=0; ch < MAXMSDCHANS; ch++) {
		if (((MStable[ch][win].ion - tol) < ion) && ((MStable[ch][win].ion + tol) > ion))
			return ch;
	}

	// No match in this time window
	return -1;

}

// Functions to pull data from MSD_Data and Time arrays.
long int MSD_Chan_Pull( int chan, int type ) {
	long msdDATA;
	static long msdTIMEold;

	if (currMSDPoint[chan] > MAXMSDPOINTS) 
		currMSDPoint[chan] = MAXMSDPOINTS;

	// type 0 is msd resp data, type 1 is msd time data.
	if ( type == 0 ) {
		msdDATA = MSD_Data_Array[chan][currMSDPoint[chan]];
		currMSDPoint[chan]++;
	} 
	else if ( type == 1 ) {		// real time displayed on text string.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEold;
		else
			msdTIMEold = msdDATA;
	}
	else if ( type == 2 ) {		// this time needs to be monitonically increasing for rtg.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEoldPlot++;
		else if ( msdDATA <= msdTIMEoldPlot ) {
			if ( msdDATA > msdTIMEoldPlot )
				msdDATA = msdDATA + 10;	
			else
				msdDATA = msdTIMEoldPlot + 10;
		}
		msdTIMEoldPlot = msdDATA;
	}

	return msdDATA;	
}




 typedef unsigned short WinNum;

 typedef long MSD_DataType;

MSD_DataType msdA_0, msdA_1, msdA_2, msdA_3, msdA_4, msdA_5, msdA_6, msdA_7, msdA_8;

int MSD_load( unsigned short IonWinNum ) {

	char *p;
	unsigned int chaninc[MAXMSDCHANS], inc, i, c;
	int chan = 0;
	float ion;

	// Initialize global currMSDPoint to 0
	for(c=0; c < MAXMSDCHANS; c++) {
		chaninc[c] = 0;
		currMSDPoint[c] = 0;
	}

	// Fills in MSD_Data_Array with "missing" data MSDMISSING
	for(i=0; i < MAXMSDPOINTS; i++) {
		for(c=0; c < MAXMSDCHANS; c++) {
			MSD_Data_Array[c][i] = MSDMISSING;
			if (c == 0)
				MSD_Time_Array[i] = MSDMISSING;
		}
	}

	// Parse data returned in string MSDresp
	p = strtok(MSDresp, ",");
	inc = 0;
	while( p != NULL ) {

		// Get ion number
		if ( (inc % 3) == 0 ) {
			ion = atof(p);
			chan = ion2chan(IonWinNum, ion);
			// printf("ion = %f, chan = %d\n", ion, chan);
		} 

		// response data
		else if ( (inc % 3) == 1 ) {
			// Set data array
			if ((chan >= 0) && (chan < MAXMSDCHANS)) {
				MSD_Data_Array[chan][chaninc[chan]] = atol(p);
				chaninc[chan]++;
				if (chaninc[chan] > MAXMSDPOINTS) {
					chaninc[chan] = MAXMSDPOINTS;
					break;
				}
			}
		} 

		// time data
		else if ( (inc % 3) == 2 ) {
			if (chan == 0)
				MSD_Time_Array[chaninc[chan] - 1] = atol(p);
		} 

		p = strtok(NULL, ",");
		inc++;
	}

	// Set MSDresp array to 0
	for (i=0; i<MAXSENDMSG; i++) 
		MSDresp[i] = '\0';
	
	return 1;

}		



	unsigned short InjectingInc_MSD = 0;


ULONG MSDchromtime;
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include "regnames.h"

#define MAXMON 	19		// should match number in msd driver

pid_t	MSDeng_proxy;
float 	MSDeng[MAXMON];

void InitializeMSDeng() {
	int param;
	static char once;

	if (once == 1) return;

	for (param=0; param<MAXMON; param++)
		MSDeng[param] = -99.0;

	once = 1;

}




 typedef double MSDdouble;
#include <sys/types.h>
#include "maycomm.h"
pid_t maycomm_proxy = 0;

TDLstruct tdl;

#define USELONGPATH  375	// use the long path TDL when less than 900 ppm
#define OffsetShortPath  150   // Offset to match long and short at switch
int P;



 typedef float tdlfloat;
 typedef float tdlfloas;
 typedef short tdlint6;
#include "integrate.h"
#include "tmctime.h"
#include "nl_dsp.h"

/* make sure the defined INTPEAKS in integrate.c
   equals the number of peaks integrated */

intStruct F11int;	
intStruct N2Oint;
intStruct SF6int;
intStruct CH4int;





int old_ssv1min;	
int old_ssvfold;
int firsthalf = -1;



 typedef float MixRatio;
MixRatio MR_F11;
MixRatio MR_N2O;
MixRatio MR_SF6;
MixRatio MR_CH4;
  char * HI_LO_text[2] = { "LO", "HI" };
  char * Op_Cl_text[2] = { " Open", "Close" };
  char * Cl_Op_text[2] = { "Close", " Open" };
  char * Off_On_text[2] = { "Off", " On" };
  char * On_Off_text[2] = { " On", " Off" };
  char * Offline_text[2] = { "---", "---" };
  char * SrtSequence_off_text[2] = { "   Off", "SrtSeq" };
  char * Load_Inject_text[3] = { " Load ", "Inject" ,"ERROR " };
  char * Inject_Load_text[3] = { "Inject", " Load " ,"ERROR " };
  char * Inj1_Inj2_text[3] = { "Inj1 ", "Inj2 ", "ERROR" };
  char * Inj2_Inj1_text[3] = { "Inj2 ", "Inj1 ", "ERROR" };
  char * BF_IN_text[2] = { "IN", "BF" };
  char * IN_BF_text[2] = { "BF", "IN" };
  char * Heat_Cool_text[2] = { "Heat", "Cool" };
  char * GCstate_text[3] = { "No Injections", " Start Inject", "             " };
  char * Air_Cal_text[2] = { "air (off)", "cal (on) " };

  #include "rtgapi.h"
  rtg_t *chromSF6_rtg[2];
  int chromSF6_rtginc = 1;
  rtg_t *chromF11_rtg[2];
  int chromF11_rtginc = 1;
  rtg_t *chromCO_rtg[2];
  int chromCO_rtginc = 1;
  rtg_t *chromPAN_rtg[2];
  int chromPAN_rtginc = 1;
  rtg_t *ecdSF6prs_rtg[2];
  int ecdSF6prs_rtginc = 1;
  double Injection_rtgbt;
  #include "tmctime.h"
  rtg_t *ecdCOprs_rtg[2];
  int ecdCOprs_rtginc = 1;
  rtg_t *ecdPANprs_rtg[2];
  int ecdPANprs_rtginc = 1;
  rtg_t *ecdMSprs_rtg[2];
  int ecdMSprs_rtginc = 1;
  rtg_t *TDLshort_rtg[2];
  int TDLshort_rtginc = 1;
  rtg_t *TDLlong_rtg[2];
  int TDLlong_rtginc = 1;
  rtg_t *msdChan0_rtg[2];
  int msdChan0_rtginc = 1;
  rtg_t *msdChan1_rtg[2];
  int msdChan1_rtginc = 1;
  rtg_t *msdChan2_rtg[2];
  int msdChan2_rtginc = 1;
  rtg_t *msdChan3_rtg[2];
  int msdChan3_rtginc = 1;
  rtg_t *msdChan4_rtg[2];
  int msdChan4_rtginc = 1;
  rtg_t *msdChan5_rtg[2];
  int msdChan5_rtginc = 1;
  void rtgext_init( void ) {
    chromSF6_rtg[0] = rtg_init( "chromSF6/0" );
    chromSF6_rtg[1] = rtg_init( "chromSF6/1" );
    chromF11_rtg[0] = rtg_init( "chromF11/0" );
    chromF11_rtg[1] = rtg_init( "chromF11/1" );
    chromCO_rtg[0] = rtg_init( "chromCO/0" );
    chromCO_rtg[1] = rtg_init( "chromCO/1" );
    chromPAN_rtg[0] = rtg_init( "chromPAN/0" );
    chromPAN_rtg[1] = rtg_init( "chromPAN/1" );
    ecdSF6prs_rtg[0] = rtg_init( "ecdSF6prs/0" );
    ecdSF6prs_rtg[1] = rtg_init( "ecdSF6prs/1" );
    ecdCOprs_rtg[0] = rtg_init( "ecdCOprs/0" );
    ecdCOprs_rtg[1] = rtg_init( "ecdCOprs/1" );
    ecdPANprs_rtg[0] = rtg_init( "ecdPANprs/0" );
    ecdPANprs_rtg[1] = rtg_init( "ecdPANprs/1" );
    ecdMSprs_rtg[0] = rtg_init( "ecdMSprs/0" );
    ecdMSprs_rtg[1] = rtg_init( "ecdMSprs/1" );
    TDLshort_rtg[0] = rtg_init( "TDLshort/0" );
    TDLshort_rtg[1] = rtg_init( "TDLshort/1" );
    TDLlong_rtg[0] = rtg_init( "TDLlong/0" );
    TDLlong_rtg[1] = rtg_init( "TDLlong/1" );
    msdChan0_rtg[0] = rtg_init( "msdChan0/0" );
    msdChan0_rtg[1] = rtg_init( "msdChan0/1" );
    msdChan1_rtg[0] = rtg_init( "msdChan1/0" );
    msdChan1_rtg[1] = rtg_init( "msdChan1/1" );
    msdChan2_rtg[0] = rtg_init( "msdChan2/0" );
    msdChan2_rtg[1] = rtg_init( "msdChan2/1" );
    msdChan3_rtg[0] = rtg_init( "msdChan3/0" );
    msdChan3_rtg[1] = rtg_init( "msdChan3/1" );
    msdChan4_rtg[0] = rtg_init( "msdChan4/0" );
    msdChan4_rtg[1] = rtg_init( "msdChan4/1" );
    msdChan5_rtg[0] = rtg_init( "msdChan5/0" );
    msdChan5_rtg[1] = rtg_init( "msdChan5/1" );
  }

  #define N_CONSOLES 3

#ifdef CONSOLE_INIT
  #error CONSOLE_INIT is obsolete
#endif
#ifdef MSG_LABEL
  #error MSG_LABEL is obsolete
#endif

#ifdef N_CONSOLES
  #include "nl_cons.h"
  #ifndef DATA_ATTR
	#define DATA_ATTR 7
  #endif

  #define cdisplay(d,r,c,s) nlcon_display(d,r,c,s,DATA_ATTR)
  #define display_(d,r,c,t,v,s) {\
	static t sv_;\
	if (v != sv_) { cdisplay(d,r,c,s); sv_ = v; }\
  }
#endif


unsigned char V0 = 0x1;
unsigned char V1 = 0x1;
unsigned char V2 = 0x1;
unsigned char V3 = 0x1;
unsigned char V4 = 0x1;
unsigned char V5 = 0x1;
unsigned char V6 = 0x1;
unsigned char V7 = 0x1;
unsigned char V8 = 0x1;
unsigned char V9 = 0x1;
unsigned char V10 = 0x3;
unsigned char V11 = 0x1;
unsigned char V12 = 0x7;
unsigned char V13 = 0x1;
unsigned char V14 = 0x1;
unsigned char V15 = 0x1;
unsigned char V16 = 0x1;
unsigned char V17 = 0x1;
unsigned char V18 = 0x1;
unsigned char V19 = 0x1;
unsigned char V20 = 0x1;
unsigned char V21 = 0x3;
unsigned char V22 = 0x3;
unsigned char V23 = 0x1;
unsigned char V24 = 0x1;
unsigned char V25 = 0x1;
unsigned char V26 = 0x1;
unsigned char V27 = 0x1;
unsigned char V28 = 0x1;
adT PresE_SF6;
GC_Ctr GC_Ctr_F11;
GC_Ctr GC_Ctr_CO;
GC_Ctr GC_Ctr_PAN;
ULONG maycX;
tdlfloas tdlP;
tdlfloat tdlsH2O;
tdlfloat tdllH2O;
union {
  struct {
    UINT MFCtr;
    GC_Ctr GC_Ctr_SF6;
    vdc_chan VoltE_CO;
    InjStateT InjState;
    Bit_Op_Cl SLoopMSout;
    vdc_chan VoltB_CO;
    vdc_chan VoltM_CO;
    adT PresE_CO;
    adT PresHead_P;
    UINT CurrFile;
    Bit_Off_On pelt1State;
    UINT CurrInj;
    Bit_HI_LO pilotTrip;
    adT_flow FlowM_SF6;
    adT PresMS1;
    UINT Synch;
  } U0;
  struct {
    char U2[2];
    MSD_DataType MSD_TimePlot;
    vdc_chan VoltE_F11;
    vdc_chan VoltBP_CO;
    vdc_chan VoltBP_SF6;
    vdc_chan VoltB_SF6;
    vdc_chan VoltM_SF6;
    adT PresBP_CO;
    adT_pump rpm_Ipump;
    adT_flow FlowM_CO;
    adT PresMS2;
    adT Trap1_re;
  } U1;
  struct {
    char U4[6];
    vdc_chan VoltE_PAN;
    vdc_chan VoltE_SF6;
    vdc_chan VoltB_F11;
    vdc_chan VoltM_F11;
    adT PresE_F11;
    adT PresE_SF6;
    adT_flow FlowB_CO;
    adT_flow FlowB_SF6;
    adT ColT_MS1;
    adT ColT_MS2;
  } U3;
  struct {
    char U6[6];
    adT Trap1_set;
    vdc_chan VoltBP_F11;
    vdc_chan VoltM_PAN;
    adT_flow FlowSrc_PAN;
    adT PresBP_PAN;
    adT PresBP_F11;
    adT PresBP_SF6;
    adT_flow FlowM_F11;
    adT ColT_PAN;
    adT PresH_N2;
  } U5;
  struct {
    char U8[6];
    adT PresL_N2;
    vdc_chan VoltB_PAN;
    vdc_chan VoltE_5;
    vdc_chan VoltBP_PAN;
    adT PresE_PAN;
    adT PresSrc_PAN;
    adT_flow FlowB_F11;
    adT Pres1_PAN;
    adT PresH_He;
    adT PresL_He;
  } U7;
  struct {
    char U10[6];
    adT Temp_F11sl;
    adT Trap2_re;
    adT Trap2_set;
    vdc_chan VoltBP_5;
    vdc_chan VoltMS2;
    vdc_chan VoltMS1;
    adT Pres2_PAN;
    adT PresBP_5;
    adT PresL_CO2;
    adT Temp_elect;
  } U9;
  struct {
    char U12[6];
    vdc_pow Pow_p28sec;
    adT PresL_N2O;
    adT Pres_Inlet;
    adT Pres_SL;
    dacMSpr PresMS1sp;
    dacMSpr PresMS2sp;
    adT PresE_5;
    adT PresH_CO2;
    adT Temp_COsl;
    vdc_pow Pow_p28pri;
  } U11;
  struct {
    char U14[6];
    Bit_Off_On trap1heat;
    Bit_Off_On trap2heat;
    adT Temp_GasBot;
    adT PresH_N2O;
    adT PresH_PAN;
    adT Flow_PANsl;
    adT Flow_Packsl;
    adT Flow_MSsl;
    adT PresL_Cal2;
    adT Temp_stack;
    vdc_pow Pow_p15pel2;
  } U13;
  struct {
    char U16[6];
    OmegaT SF6_Post;
    OmegaTsp SF6_Post_Sp;
    vdc_pow Pow_p5;
    adT PresL_PAN;
    adT PresL_ZA;
    adT PresH_ZA;
    adT PresH_Cal1;
    adT PresH_Cal2;
    adT Temp_SF6sl;
    vdc_pow Pow_p15pel1;
    vdc_pow Pow_p12;
  } U15;
  struct {
    char U18[6];
    valveMS2text valv_MS2;
    valveMS1text valv_MS1;
    Bit_HI_LO faildummy;
    valvetext valv_CO;
    adT Temp_GSVbo;
    adT Temp_Ipump;
    adT Temp_PANlmp;
    adT Temp_PANsl;
    adT PresL_Cal1;
    vdc_pow Pow_p24gsv;
    vdc_pow Pow_m15;
    vdc_pow Pow_p15;
  } U17;
  struct {
    char U20[6];
    MSD_DataType MSD_Time;
    Bit_Cl_Op SLoopIN;
    WinNum IonWinNum;
    Bit_Cl_Op SLoopOUT;
    OmegaT Trap1_CB;
    Bit_Off_On PANflowCont;
    Bit_Cl_Op PANflsh;
    Bit_Off_On PANlamp;
    Bit_Air_Cal PANsol1;
    Bit_Off_On trap2relay;
    UCHAR GCstate;
    UCHAR MSDstate;
    adT Temp_PANsrc;
    Bit_Off_On pelt2State;
    UINT CurrInj_MSD;
    vdc_pow Pow_p24ms;
    OmegaT F11_ECD;
    OmegaTsp F11_ECD_Sp;
  } U19;
  struct {
    char U22[6];
    MSDdouble msdEEGY;
    OmegaT PAN_ECD;
    OmegaTsp PAN_ECD_Sp;
    OmegaTsp Trap1_CB_Sp;
    Bit_Off_On trap1relay;
    OmegaT CO_Col;
    OmegaTsp CO_Col_Sp;
    Bit_Cl_Op PANsol2;
    Bit_Off_On PANsol3;
    Bit_Op_Cl PANsol4;
    UINT CurrFile_MSD;
    GC_Ctr GC_Ctr_CO;
    OmegaT F11_Col;
    OmegaTsp F11_Col_Sp;
    OmegaT SF6_ECD;
    OmegaTsp SF6_ECD_Sp;
  } U21;
  struct {
    char U24[6];
    MSDdouble msdFSEL;
    valvetext valv_F11;
    valvetext valv_SF6;
    valvT ssv2;
    valvT ssv1;
    OmegaT Trap2_CB;
    OmegaTsp Trap2_CB_Sp;
    OmegaT CO_ECD;
    OmegaTsp CO_ECD_Sp;
    MSD_DataType MSD_Chan0;
    tdlfloas tdlP;
    OmegaT SF6_Col;
    OmegaTsp SF6_Col_Sp;
    GC_Ctr GC_Ctr_PAN;
  } U23;
  struct {
    char U26[6];
    MSDdouble msdEMUL;
    MSD_DataType MSD_Chan4;
    MSD_DataType MSD_Chan3;
    MSD_DataType MSD_Chan2;
    MSD_DataType MSD_Chan1;
    MSDdouble msdECUR;
    GC_Ctr GC_Ctr_F11;
    ULONG maycX;
  } U25;
  struct {
    char U28[6];
    MSDdouble msdMASO;
    MSDdouble msdREP;
    MSDdouble msdIPOL;
    MSDdouble msdAMUO;
    MSDdouble msdAMUG;
  } U27;
  struct {
    char U30[6];
    tdlint6  tdllZer;
    tdlint6  tdllPos;
    valvetext valv_PAN;
    UINT loadMSDarray;
    MSDdouble msdENT;
    MSDdouble msdIFOC;
    MSDdouble msdENTO;
    MSDdouble msdMMW;
  } U29;
  struct {
    char U32[10];
    MSD_DataType MSD_Chan5;
    MSDdouble msdCAL;
    MSDdouble msdHEDEN;
    MSDdouble msdQUAD;
    MSDdouble msdSRCTEMP;
  } U31;
  struct {
    char U34[10];
    tdlint6  tdllPow;
    tdlint6  tdllAmp;
    MSDdouble msdMASG;
    MSDdouble msdTURBOPCT;
    tdlfloas tdlT;
    tdlfloat tdlbH2O;
  } U33;
  struct {
    char U36[14];
    tdlint6  tdlsZer;
    tdlint6  tdlsPos;
    tdlint6  tdlsPow;
    tdlint6  tdlsAmp;
    tdlfloat tdllH2O;
    tdlfloat tdlsH2O;
  } U35;
} *home;
/* doub icvt for MixRatio -> MixRatio */
double _CVT_0( MixRatio x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
char *SL_6_1_f_4( long int x) {
  static char obuf[7];
  int neg;
  int iov;

  if (x < -9999 || x > 99999) return("******");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  iov = x/10;
  obuf[4] = '.';
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_1() int tcvt MixRatio -> MixRatio */
char *_CVT_1(MixRatio x) {
  double iv;

  iv = _CVT_0( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
char *SS_6_224_d_0( short int x) {
  static char obuf[7];
  int neg;

  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[4] = '-'; goto space3; }
    else goto space4;
  }
  obuf[4] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[3] = '-'; goto space2; }
    else goto space3;
  }
  obuf[3] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (x % 10) + '0';
  goto nospace;
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* doub icvt for tdlfloas -> tdlfloas */
double _CVT_2( tdlfloas x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_3() int tcvt tdlfloas -> tdlfloas */
char *_CVT_3(tdlfloas x) {
  double iv;

  iv = _CVT_2( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for tdlfloat -> tdlfloat */
double _CVT_4( tdlfloat x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
char *SL_8_1_f_4( long int x) {
  static char obuf[9];
  int neg;
  int iov;

  if (x < -999999 || x > 9999999) return("********");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[8] = '\0';
  obuf[7] = (x % 10) + '0';
  x /= 10;
  obuf[6] = '.';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[4] = '-'; goto space3; }
    else goto space4;
  }
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) {
    if (neg) { obuf[3] = '-'; goto space2; }
    else goto space3;
  }
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_5() int tcvt tdlfloat -> tdlfloat */
char *_CVT_5(tdlfloat x) {
  double iv;

  iv = _CVT_4( x );
  if ( iv < -999999 || iv > 9999999 )
	return "********";
  return SL_8_1_f_4( iv );
}
/* doub icvt for MSDdouble -> MSDdouble */
double _CVT_6( MSDdouble x ) {
  return (double) floor(  x  * 1E3 + .5 );
}
char *SL_8_3_f_4( long int x) {
  static char obuf[9];
  int neg;
  int iov;

  if (x < -999999 || x > 9999999) return("********");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[8] = '\0';
  obuf[7] = (x % 10) + '0';
  x /= 10;
  obuf[6] = (x % 10) + '0';
  x /= 10;
  obuf[5] = (x % 10) + '0';
  iov = x/10;
  obuf[4] = '.';
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_7() int tcvt MSDdouble -> MSDdouble */
char *_CVT_7(MSDdouble x) {
  double iv;

  iv = _CVT_6( x );
  if ( iv < -999999 || iv > 9999999 )
	return "********";
  return SL_8_3_f_4( iv );
}
char *SL_9_224_d_8( long int x) {
  static char obuf[10];
  int neg;
  int iov;

  if (x < -99999999 || x > 999999999) return("*********");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[9] = '\0';
  obuf[8] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[7] = '-'; goto space6; }
    else goto space7;
  }
  obuf[7] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[6] = '-'; goto space5; }
    else goto space6;
  }
  obuf[6] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[5] = '-'; goto space4; }
    else goto space5;
  }
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[4] = '-'; goto space3; }
    else goto space4;
  }
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) {
    if (neg) { obuf[3] = '-'; goto space2; }
    else goto space3;
  }
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space7: obuf[7] = ' ';
  space6: obuf[6] = ' ';
  space5: obuf[5] = ' ';
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_8() int tcvt MSD_DataType -> MSD_DataType */
char *_CVT_8(MSD_DataType x) {
  if ( x < -99999999 || x > 999999999 )
	return "*********";
  return SL_9_224_d_8( x );
}
char *US_3_0_d_0( unsigned short int x) {
  static char obuf[4];

  if (x > 999) return("***");
  obuf[3] = '\0';
  obuf[2] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space1;
  obuf[1] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space0;
  obuf[0] = (x % 10) + '0';
  goto nospace;
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_9() int tcvt WinNum -> WinNum */
char *_CVT_9(WinNum x) {
  if ( x > 999 )
	return "***";
  return US_3_0_d_0( x );
}
char *US_3_224_u_0( unsigned short int x) {
  static char obuf[4];

  if (x > 999) return("***");
  obuf[3] = '\0';
  obuf[2] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space1;
  obuf[1] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space0;
  obuf[0] = (x % 10) + '0';
  goto nospace;
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_10() int tcvt valvT -> valvT */
char *_CVT_10(valvT x) {
  if ( x < 0 || x > 999 )
	return "***";
  return US_3_224_u_0( x );
}
char *SL_6_224_d_8( long int x) {
  static char obuf[7];
  int neg;
  int iov;

  if (x < -99999 || x > 999999) return("******");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[4] = '-'; goto space3; }
    else goto space4;
  }
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) {
    if (neg) { obuf[3] = '-'; goto space2; }
    else goto space3;
  }
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_11() int tcvt GC_Freq -> GC_Freq */
char *_CVT_11(GC_Freq x) {
  if ( x < -99999 || x > 999999 )
	return "******";
  return SL_6_224_d_8( x );
}
char *SS_6_1_f_4( short int x) {
  static char obuf[7];
  int neg;

  if (x < -9999) return("******");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  obuf[4] = '.';
  obuf[3] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (x % 10) + '0';
  goto nospace;
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_12() int tcvt OmegaTsp -> OmegaTsp */
char *_CVT_12(OmegaTsp x) {
  if ( x < -9999 )
	return "******";
  return SS_6_1_f_4( x );
}
/* _CVT_13() int tcvt OmegaT -> OmegaT */
char *_CVT_13(OmegaT x) {
  if ( x < -9999 )
	return "******";
  return SS_6_1_f_4( x );
}
/* doub icvt for dacMSpr -> dacMSpr */
double _CVT_14( dacMSpr x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_15() int tcvt dacMSpr -> dacMSpr */
char *_CVT_15(dacMSpr x) {
  double iv;

  iv = _CVT_14( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for vdc_pow -> vdc_pow */
double _CVT_16( vdc_pow x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_17() int tcvt vdc_pow -> vdc_pow */
char *_CVT_17(vdc_pow x) {
  double iv;

  iv = _CVT_16( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for vdc_chan -> vdc_chan */
double _CVT_18( vdc_chan x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_19() int tcvt vdc_chan -> vdc_chan */
char *_CVT_19(vdc_chan x) {
  double iv;

  iv = _CVT_18( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for adT_flow -> adT_flow */
double _CVT_20( adT_flow x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_21() int tcvt adT_flow -> adT_flow */
char *_CVT_21(adT_flow x) {
  double iv;

  iv = _CVT_20( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for adT -> adT */
double _CVT_22( adT x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_23() int tcvt adT -> adT */
char *_CVT_23(adT x) {
  double iv;

  iv = _CVT_22( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
char *UL_6_0_u_0( unsigned long int x) {
  static char obuf[7];
  int iov;

  if (x > 999999) return("******");
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space4;
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) goto space3;
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space2;
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space1;
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space0;
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_24() int tcvt ULONG -> ULONG */
char *_CVT_24(ULONG x) {
  if ( x > 999999 )
	return "******";
  return UL_6_0_u_0( x );
}
/* Text array for UCHAR -> UCHAR */
static char _CVT_25[256][4] = {
  "  0", "  1", "  2", "  3", "  4", "  5", "  6", "  7", "  8", "  9",
  " 10", " 11", " 12", " 13", " 14", " 15", " 16", " 17", " 18", " 19",
  " 20", " 21", " 22", " 23", " 24", " 25", " 26", " 27", " 28", " 29",
  " 30", " 31", " 32", " 33", " 34", " 35", " 36", " 37", " 38", " 39",
  " 40", " 41", " 42", " 43", " 44", " 45", " 46", " 47", " 48", " 49",
  " 50", " 51", " 52", " 53", " 54", " 55", " 56", " 57", " 58", " 59",
  " 60", " 61", " 62", " 63", " 64", " 65", " 66", " 67", " 68", " 69",
  " 70", " 71", " 72", " 73", " 74", " 75", " 76", " 77", " 78", " 79",
  " 80", " 81", " 82", " 83", " 84", " 85", " 86", " 87", " 88", " 89",
  " 90", " 91", " 92", " 93", " 94", " 95", " 96", " 97", " 98", " 99",
  "100", "101", "102", "103", "104", "105", "106", "107", "108", "109",
  "110", "111", "112", "113", "114", "115", "116", "117", "118", "119",
  "120", "121", "122", "123", "124", "125", "126", "127", "128", "129",
  "130", "131", "132", "133", "134", "135", "136", "137", "138", "139",
  "140", "141", "142", "143", "144", "145", "146", "147", "148", "149",
  "150", "151", "152", "153", "154", "155", "156", "157", "158", "159",
  "160", "161", "162", "163", "164", "165", "166", "167", "168", "169",
  "170", "171", "172", "173", "174", "175", "176", "177", "178", "179",
  "180", "181", "182", "183", "184", "185", "186", "187", "188", "189",
  "190", "191", "192", "193", "194", "195", "196", "197", "198", "199",
  "200", "201", "202", "203", "204", "205", "206", "207", "208", "209",
  "210", "211", "212", "213", "214", "215", "216", "217", "218", "219",
  "220", "221", "222", "223", "224", "225", "226", "227", "228", "229",
  "230", "231", "232", "233", "234", "235", "236", "237", "238", "239",
  "240", "241", "242", "243", "244", "245", "246", "247", "248", "249",
  "250", "251", "252", "253", "254", "255"
};
char *US_5_0_u_0( unsigned short int x) {
  static char obuf[6];
  int iov;

  obuf[5] = '\0';
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) goto space3;
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space2;
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space1;
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space0;
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}

static void VSET_3_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* MaycommTog */
      V9 |= 0x1;
      break;
    case 1: /* MaycommInc */ {
        V22 |= 0x1;
        V21 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* MaycommTog */
      V9 &= ~0x1;
      break;
    case 1: /* MaycommInc */ {
        V22 &= ~0x1;
        V21 &= ~0x1;
        {
          rtg_increment( TDLshort_rtginc, 2 );
          rtg_increment( TDLlong_rtginc, 2 );
        }
      }
      break;
  }
}
static void VSET_2_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection_MSD */ {
        V28 |= 0x1;
        V27 |= 0x1;
        V26 |= 0x1;
        V25 |= 0x1;
        V24 |= 0x1;
        V23 |= 0x1;
        V7 |= 0x1;
      }
      break;
    case 2: /* Injecting_MSD */ {
        V8 |= 0x1;
        V6 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection_MSD */ {
        V28 &= ~0x1;
        V27 &= ~0x1;
        V26 &= ~0x1;
        V25 &= ~0x1;
        V24 &= ~0x1;
        V23 &= ~0x1;
        V7 &= ~0x1;
        {
          rtg_increment( msdChan0_rtginc, 2 );
          rtg_increment( msdChan1_rtginc, 2 );
          rtg_increment( msdChan2_rtginc, 2 );
          rtg_increment( msdChan3_rtginc, 2 );
          rtg_increment( msdChan4_rtginc, 2 );
          rtg_increment( msdChan5_rtginc, 2 );
        }
      }
      break;
    case 2: /* Injecting_MSD */ {
        V8 &= ~0x1;
        V6 &= ~0x1;
        {
        	msdTIMEoldPlot = 0;
        }
      }
      break;
    case 1: /* NotInjecting_MSD */ {
        {
        	ReadMSDionFile( MSDIONFILE );
        } {
        	InitializeMSDeng();
        }
      }
      break;
  }
}
static void VSET_1_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* GCTog */
      V4 |= 0x1;
      break;
    case 1: /* GCInc */ {
        V16 |= 0x1;
        V15 |= 0x1;
        V14 |= 0x1;
        V13 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* GCTog */
      V4 &= ~0x1;
      break;
    case 1: /* GCInc */ {
        V16 &= ~0x1;
        V15 &= ~0x1;
        V14 &= ~0x1;
        V13 &= ~0x1;
        {
          rtg_increment( chromSF6_rtginc, 2 );
          rtg_increment( chromF11_rtginc, 2 );
          rtg_increment( chromCO_rtginc, 2 );
          rtg_increment( chromPAN_rtginc, 2 );
        }
      }
      break;
  }
}
static void VSET_0_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection */ {
        V20 |= 0x1;
        V19 |= 0x1;
        V18 |= 0x1;
        V17 |= 0x1;
        V12 |= 0x1;
        V1 |= 0x1;
      }
      break;
    case 2: /* Injecting */ {
        V11 |= 0x1;
        V5 |= 0x1;
        V2 |= 0x1;
        V0 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection */ {
        V20 &= ~0x1;
        V19 &= ~0x1;
        V18 &= ~0x1;
        V17 &= ~0x1;
        V12 &= ~0x1;
        V1 &= ~0x1;
        { 
        	MR_F11 = MRres( 0 ); {
          display_(0,9,55,
          MixRatio,MR_F11,_CVT_1(MR_F11));
        }
        } { 
        	MR_N2O = MRres( 1 ); {
          display_(0,10,55,
          MixRatio,MR_N2O,_CVT_1(MR_N2O));
        }
        } { 
        	MR_SF6 = MRres( 2 ); {
          display_(0,11,55,
          MixRatio,MR_SF6,_CVT_1(MR_SF6));
        }
        } { 
        	MR_CH4 = MRres( 3 ); {
          display_(0,12,55,
          MixRatio,MR_CH4,_CVT_1(MR_CH4));
        }
        } {
          rtg_increment( ecdSF6prs_rtginc, 2 );
          rtg_increment( ecdCOprs_rtginc, 2 );
          rtg_increment( ecdPANprs_rtginc, 2 );
          rtg_increment( ecdMSprs_rtginc, 2 );
          Injection_rtgbt = dtime();
        }
      }
      break;
    case 2: /* Injecting */ {
        V11 &= ~0x1;
        V5 &= ~0x1;
        V2 &= ~0x1;
        V0 &= ~0x1;
        {
            firsthalf = (++firsthalf == 2) ? 0 : 1;
        }
      }
      break;
    case 1: /* NotInjecting */ {
        {
        	F11int.mol = "f11";		
        	F11int.pnum = 0;		
        	F11int.strt = 4;		
        	F11int.stop = 22;		
        	F11int.calval = 248.02;	
        	F11int.calssv = 2;		
        	F11int.delay = 70;		
        
        	N2Oint.mol = "n2o";		
        	N2Oint.pnum = 1;		
        	N2Oint.strt = 48;		
        	N2Oint.stop = 68;		
        	N2Oint.calval = 320.28;	
        	N2Oint.calssv = 2;		
        	N2Oint.delay = 0;
        
        	SF6int.mol = "sf6";		
        	SF6int.pnum = 2;		
        	SF6int.strt = 36;		
        	SF6int.stop = 44;		
        	SF6int.calval = 6.32;	
        	SF6int.calssv = 2;		
        	SF6int.delay = 0;
        
        	CH4int.mol = "ch4";		
        	CH4int.pnum = 3;		
        	CH4int.strt = 17;		
        	CH4int.stop = 36;		
        	CH4int.calval = 1828.7;	
        	CH4int.calssv = 2;		
        	CH4int.delay = 70;		
        
        } {
            firsthalf = -1;
        }
      }
      break;
  }
}
static void tminitfunc(void) {VSET_0_(1);VSET_1_(1);VSET_2_(1);VSET_3_(1);
  cdisplay(0,1,14,_CVT_24(0));
  cdisplay(0,1,32,US_5_0_u_0(0));
  cdisplay(0,2,14,_CVT_24(0));
  cdisplay(0,4,16,_CVT_23(0));
  cdisplay(0,5,16,_CVT_23(0));
  cdisplay(0,5,24,_CVT_19(0));
  cdisplay(0,5,42,_CVT_23(0));
  cdisplay(0,6,16,_CVT_23(0));
  cdisplay(0,6,24,_CVT_19(0));
  cdisplay(0,6,42,_CVT_23(0));
  cdisplay(0,8,10,_CVT_10(0));
  cdisplay(0,8,17,_CVT_10(0));
  cdisplay(0,8,26,Air_Cal_text[0]);
  cdisplay(0,9,29,Off_On_text[0]);
  cdisplay(0,9,35,Off_On_text[0]);
  cdisplay(0,9,41,Off_On_text[0]);
  cdisplay(0,10,25,_CVT_21(0));
  cdisplay(0,10,32,_CVT_23(0));
  cdisplay(0,1,62,HI_LO_text[0]);
  cdisplay(0,2,62,HI_LO_text[0]);
  cdisplay(0,5,56,Cl_Op_text[0]);
  cdisplay(0,5,62,Cl_Op_text[0]);
  cdisplay(0,6,56,Cl_Op_text[0]);
  cdisplay(0,6,62,Op_Cl_text[0]);
  cdisplay(0,7,63,Cl_Op_text[0]);
  cdisplay(0,9,55,_CVT_1(0));
  cdisplay(0,10,55,_CVT_1(0));
  cdisplay(0,11,55,_CVT_1(0));
  cdisplay(0,12,55,_CVT_1(0));
  cdisplay(0,14,25,Load_Inject_text[0]);
  cdisplay(0,15,7,_CVT_11(0));
  cdisplay(0,16,7,_CVT_13(0));
  cdisplay(0,16,20,_CVT_12(0));
  cdisplay(0,17,7,_CVT_13(0));
  cdisplay(0,17,20,_CVT_12(0));
  cdisplay(0,18,7,_CVT_13(0));
  cdisplay(0,18,20,_CVT_12(0));
  cdisplay(0,19,7,_CVT_21(0));
  cdisplay(0,19,20,_CVT_19(0));
  cdisplay(0,20,7,_CVT_21(0));
  cdisplay(0,20,20,_CVT_19(0));
  cdisplay(0,21,7,_CVT_23(0));
  cdisplay(0,21,20,_CVT_19(0));
  cdisplay(0,22,7,_CVT_23(0));
  cdisplay(0,22,20,_CVT_19(0));
  cdisplay(0,14,59,Load_Inject_text[0]);
  cdisplay(0,15,42,_CVT_11(0));
  cdisplay(0,16,42,_CVT_13(0));
  cdisplay(0,16,55,_CVT_12(0));
  cdisplay(0,17,42,_CVT_13(0));
  cdisplay(0,17,55,_CVT_12(0));
  cdisplay(0,18,42,_CVT_21(0));
  cdisplay(0,18,55,_CVT_19(0));
  cdisplay(0,19,42,_CVT_21(0));
  cdisplay(0,19,55,_CVT_19(0));
  cdisplay(0,20,42,_CVT_23(0));
  cdisplay(0,20,55,_CVT_19(0));
  cdisplay(0,21,42,_CVT_23(0));
  cdisplay(0,21,55,_CVT_19(0));
  cdisplay(0,24,24,Load_Inject_text[0]);
  cdisplay(0,25,7,_CVT_11(0));
  cdisplay(0,26,7,_CVT_13(0));
  cdisplay(0,26,20,_CVT_12(0));
  cdisplay(0,27,7,_CVT_13(0));
  cdisplay(0,27,20,_CVT_12(0));
  cdisplay(0,28,7,_CVT_21(0));
  cdisplay(0,28,20,_CVT_19(0));
  cdisplay(0,29,7,_CVT_21(0));
  cdisplay(0,29,20,_CVT_19(0));
  cdisplay(0,30,7,_CVT_23(0));
  cdisplay(0,30,20,_CVT_19(0));
  cdisplay(0,31,7,_CVT_23(0));
  cdisplay(0,31,20,_CVT_19(0));
  cdisplay(0,24,59,Load_Inject_text[0]);
  cdisplay(0,25,42,_CVT_11(0));
  cdisplay(0,26,42,_CVT_13(0));
  cdisplay(0,26,55,_CVT_12(0));
  cdisplay(0,27,42,_CVT_23(0));
  cdisplay(0,28,42,_CVT_23(0));
  cdisplay(0,28,55,_CVT_19(0));
  cdisplay(0,29,42,_CVT_23(0));
  cdisplay(0,29,55,_CVT_19(0));
  cdisplay(0,30,42,_CVT_23(0));
  cdisplay(0,30,55,_CVT_19(0));
  cdisplay(1,3,18,_CVT_23(0));
  cdisplay(1,4,18,_CVT_23(0));
  cdisplay(1,5,18,_CVT_23(0));
  cdisplay(1,6,18,_CVT_23(0));
  cdisplay(1,7,18,_CVT_23(0));
  cdisplay(1,8,18,_CVT_23(0));
  cdisplay(1,9,18,_CVT_23(0));
  cdisplay(1,10,18,_CVT_23(0));
  cdisplay(1,11,18,_CVT_23(0));
  cdisplay(1,12,18,_CVT_23(0));
  cdisplay(1,13,18,_CVT_23(0));
  cdisplay(1,3,42,_CVT_17(0));
  cdisplay(1,4,42,_CVT_17(0));
  cdisplay(1,5,42,_CVT_17(0));
  cdisplay(1,6,42,_CVT_17(0));
  cdisplay(1,7,42,_CVT_17(0));
  cdisplay(1,8,42,_CVT_17(0));
  cdisplay(1,9,42,_CVT_17(0));
  cdisplay(1,10,42,_CVT_17(0));
  cdisplay(1,11,42,_CVT_17(0));
  cdisplay(1,12,42,_CVT_17(0));
  cdisplay(1,4,56,_CVT_23(0));
  cdisplay(1,4,64,_CVT_23(0));
  cdisplay(1,5,56,_CVT_23(0));
  cdisplay(1,5,64,_CVT_23(0));
  cdisplay(1,6,56,_CVT_23(0));
  cdisplay(1,6,64,_CVT_23(0));
  cdisplay(1,7,56,_CVT_23(0));
  cdisplay(1,7,64,_CVT_23(0));
  cdisplay(1,8,56,_CVT_23(0));
  cdisplay(1,8,64,_CVT_23(0));
  cdisplay(1,9,56,_CVT_23(0));
  cdisplay(1,9,64,_CVT_23(0));
  cdisplay(1,10,56,_CVT_23(0));
  cdisplay(1,10,64,_CVT_23(0));
  cdisplay(1,11,56,_CVT_23(0));
  cdisplay(1,11,64,_CVT_23(0));
  cdisplay(1,16,12,_CVT_13(0));
  cdisplay(1,16,20,_CVT_12(0));
  cdisplay(1,16,33,_CVT_13(0));
  cdisplay(1,16,41,_CVT_12(0));
  cdisplay(1,16,54,_CVT_13(0));
  cdisplay(1,16,62,_CVT_12(0));
  cdisplay(1,17,12,_CVT_13(0));
  cdisplay(1,17,20,_CVT_12(0));
  cdisplay(1,17,33,_CVT_13(0));
  cdisplay(1,17,41,_CVT_12(0));
  cdisplay(1,18,12,_CVT_13(0));
  cdisplay(1,18,20,_CVT_12(0));
  cdisplay(1,18,33,_CVT_13(0));
  cdisplay(1,18,41,_CVT_12(0));
  cdisplay(1,19,12,_CVT_13(0));
  cdisplay(1,19,20,_CVT_12(0));
  cdisplay(1,20,18,_CVT_13(0));
  cdisplay(1,20,26,_CVT_12(0));
  cdisplay(1,20,38,_CVT_13(0));
  cdisplay(1,20,46,_CVT_12(0));
  cdisplay(1,23,11,_CVT_3(0));
  cdisplay(1,24,11,_CVT_3(0));
  cdisplay(1,27,11,_CVT_5(0));
  cdisplay(1,23,36,_CVT_5(0));
  cdisplay(1,24,38,SS_6_224_d_0(0));
  cdisplay(1,25,38,SS_6_224_d_0(0));
  cdisplay(1,26,38,SS_6_224_d_0(0));
  cdisplay(1,27,38,SS_6_224_d_0(0));
  cdisplay(1,23,58,_CVT_5(0));
  cdisplay(1,24,60,SS_6_224_d_0(0));
  cdisplay(1,25,60,SS_6_224_d_0(0));
  cdisplay(1,26,60,SS_6_224_d_0(0));
  cdisplay(1,27,60,SS_6_224_d_0(0));
  cdisplay(2,3,10,_CVT_8(0));
  cdisplay(2,3,30,_CVT_8(0));
  cdisplay(2,4,10,_CVT_8(0));
  cdisplay(2,4,30,_CVT_8(0));
  cdisplay(2,5,10,_CVT_8(0));
  cdisplay(2,6,10,_CVT_8(0));
  cdisplay(2,7,12,_CVT_8(0));
  cdisplay(2,10,14,_CVT_24(0));
  cdisplay(2,10,35,US_5_0_u_0(0));
  cdisplay(2,11,14,_CVT_24(0));
  cdisplay(2,11,37,_CVT_9(0));
  cdisplay(2,14,11,_CVT_10(0));
  cdisplay(2,14,29,_CVT_10(0));
  cdisplay(2,15,12,_CVT_25[0]);
  cdisplay(2,16,11,Inj2_Inj1_text[0]);
  cdisplay(2,16,29,Inj2_Inj1_text[0]);
  cdisplay(2,19,8,_CVT_23(0));
  cdisplay(2,19,21,_CVT_19(0));
  cdisplay(2,20,8,_CVT_23(0));
  cdisplay(2,21,16,Op_Cl_text[0]);
  cdisplay(2,23,12,_CVT_23(0));
  cdisplay(2,23,24,_CVT_19(0));
  cdisplay(2,26,20,_CVT_23(0));
  cdisplay(2,26,33,_CVT_19(0));
  cdisplay(2,27,20,_CVT_15(0));
  cdisplay(2,28,20,_CVT_23(0));
  cdisplay(2,29,20,_CVT_23(0));
  cdisplay(2,29,33,_CVT_19(0));
  cdisplay(2,30,20,_CVT_15(0));
  cdisplay(2,31,20,_CVT_23(0));
  cdisplay(2,26,49,_CVT_13(0));
  cdisplay(2,27,49,_CVT_23(0));
  cdisplay(2,27,62,_CVT_23(0));
  cdisplay(2,28,49,Off_On_text[0]);
  cdisplay(2,28,56,Off_On_text[0]);
  cdisplay(2,28,67,Off_On_text[0]);
  cdisplay(2,30,49,_CVT_13(0));
  cdisplay(2,31,49,_CVT_23(0));
  cdisplay(2,31,62,_CVT_23(0));
  cdisplay(2,32,49,Off_On_text[0]);
  cdisplay(2,32,56,Off_On_text[0]);
  cdisplay(2,32,67,Off_On_text[0]);
  cdisplay(2,3,65,_CVT_7(0));
  cdisplay(2,4,65,_CVT_7(0));
  cdisplay(2,5,65,_CVT_7(0));
  cdisplay(2,6,65,_CVT_7(0));
  cdisplay(2,7,65,_CVT_7(0));
  cdisplay(2,8,65,_CVT_7(0));
  cdisplay(2,10,65,_CVT_7(0));
  cdisplay(2,11,65,_CVT_7(0));
  cdisplay(2,12,65,_CVT_7(0));
  cdisplay(2,13,65,_CVT_7(0));
  cdisplay(2,14,65,_CVT_7(0));
  cdisplay(2,15,65,_CVT_7(0));
  cdisplay(2,17,65,_CVT_7(0));
  cdisplay(2,18,65,_CVT_7(0));
  cdisplay(2,19,65,_CVT_7(0));
  cdisplay(2,20,65,_CVT_7(0));
  cdisplay(2,21,65,_CVT_7(0));
  cdisplay(2,22,65,_CVT_7(0));
  cdisplay(2,23,65,_CVT_7(0));
}
#define TMINITFUNC tminitfunc()

static void nullfunc(void);
static void BF2_0(void) {
  GC_Ctr_PAN = home->U23.GC_Ctr_PAN;
  GC_Ctr_F11 = home->U25.GC_Ctr_F11;
  GC_Ctr_CO = home->U21.GC_Ctr_CO; {
    V12 &= ~0x4;
    V3 &= ~0x1;
  }
  {
  
  	for(chanInc=0; chanInc<MAXMSDCHANS; chanInc++) {
  		MSD_ChanX = MSDMISSING;
  		switch( chanInc ) {
  			case 0:
  				MSD_ChanX = home->U23.MSD_Chan0; break;
  			case 1:
  				MSD_ChanX = home->U25.MSD_Chan1; break;
  			case 2:
  				MSD_ChanX = home->U25.MSD_Chan2; break;
  			case 3:
  				MSD_ChanX = home->U25.MSD_Chan3; break;
  			case 4:
  				MSD_ChanX = home->U25.MSD_Chan4; break;
  			case 5:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			case 6:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			case 7:
  				MSD_ChanX = home->U31.MSD_Chan5; break;
  			default:
  				chanInc = MAXMSDCHANS-1; MSD_ChanX = MSDMISSING; break;
  		}
  
  		if ( MSD_ChanX > 0 ) {
  			msd_sum[chanInc] += MSD_ChanX;
  			MSchanAvg[chanInc]++;
  		}
  	}
  }
  if ( GC_Ctr_F11 >= 0 )if (!(V14)) {
    {
      	rtg_report( chromF11_rtg[ chromF11_rtginc ], ecdF11x, GC_Ctr_F11 );
    }
  }
  if ( GC_Ctr_CO >= 0 )if (!(V15)) {
    {
      	rtg_report( chromCO_rtg[ chromCO_rtginc ], ecdCOx, GC_Ctr_CO );
    }
  }
  if ( GC_Ctr_PAN >= 0 )if (!(V16)) {
    {
      	rtg_report( chromPAN_rtg[ chromPAN_rtginc ], ecdPANx, GC_Ctr_PAN );
    }
  }
  if ( home->U23.MSD_Chan0 >= 0 )if (!(V23)) {
    {
      	rtg_report( msdChan0_rtg[ msdChan0_rtginc ], home->U1.MSD_TimePlot, home->U23.MSD_Chan0 );
    }
  }
  if ( home->U25.MSD_Chan1 >= 0 )if (!(V24)) {
    {
      	rtg_report( msdChan1_rtg[ msdChan1_rtginc ], home->U1.MSD_TimePlot, home->U25.MSD_Chan1 );
    }
  }
  if ( home->U25.MSD_Chan2 >= 0 )if (!(V25)) {
    {
      	rtg_report( msdChan2_rtg[ msdChan2_rtginc ], home->U1.MSD_TimePlot, home->U25.MSD_Chan2 );
    }
  }
  if ( home->U25.MSD_Chan3 >= 0 )if (!(V26)) {
    {
      	rtg_report( msdChan3_rtg[ msdChan3_rtginc ], home->U1.MSD_TimePlot, home->U25.MSD_Chan3 );
    }
  }
  if ( home->U25.MSD_Chan4 >= 0 )if (!(V27)) {
    {
      	rtg_report( msdChan4_rtg[ msdChan4_rtginc ], home->U1.MSD_TimePlot, home->U25.MSD_Chan4 );
    }
  }
  if ( home->U31.MSD_Chan5 >= 0 )if (!(V28)) {
    {
      	rtg_report( msdChan5_rtg[ msdChan5_rtginc ], home->U1.MSD_TimePlot, home->U31.MSD_Chan5 );
    }
  }
  display_(2,7,12,
   MSD_DataType,home->U19.MSD_Time,_CVT_8(home->U19.MSD_Time));
}

static void BF32_0(void) {
  BF2_0();
  {if (!(V1)) {
    { CHROMtime += 1; InjectingInc = 0; {
      V12 &= ~0x2;
      display_(0,1,14,
      ULONG,CHROMtime,_CVT_24(CHROMtime));
    }
    }
  }if (!(V2)) {
    { 
    	if (InjectingInc == 0 ) {
    		CHROMtime = 1; 
    		InjectingInc = 1;
    	}
    	else CHROMtime += 1; {
      V12 &= ~0x2;
      display_(0,1,14,
      ULONG,CHROMtime,_CVT_24(CHROMtime));
    }
    }
  }
  }
  {	
  	if (rs485_proxy != 0)  Trigger ( rs485_proxy );
  }
  {
  	if (ECDresp_proxy != 0) Trigger ( ECDresp_proxy );
  }
  {if (!(V4)) {
    { VSET_1_(1);
    	}
  }if (!(V5)) {
    V5 |= 0x1;
    { VSET_1_(2);
    		ecdSF6x = 0.0;
    		ecdF11x = 0.0;
    		ecdCOx  = 0.0;
    		ecdPANx = 0.0;
    	}
  }
  
  	if ( ecdSF6x > NUMSECSXAXIS ) { VSET_1_(2);
  		ecdSF6x = 0.0;
  		ecdF11x = 0.0;
  		ecdCOx  = 0.0;
  		ecdPANx = 0.0;
  	}
  }
  {
  	if ( DetAvgCt1 > 0 ) {
  		ecdA_SF6 = ecd_sum1/DetAvgCt1;
  		ecdA_SF6save = ecdA_SF6;
  		DetAvgCt1 = 0;
  		ecd_sum1 = 0;
  		DetAvgOffline1 = 0;
  	} 
  	else if (( ecdA_SF6save > 0 ) && ( DetAvgOffline1 < 1 )) {
  		DetAvgOffline1++;
  		ecdA_SF6 = ecdA_SF6save;
  	}
  	else {
  		ecdA_SF6 = ECDOFFLINE;
  		ecdA_SF6save = 0;
  	} {
    display_(0,15,7,
    
    GC_Freq,ecdA_SF6,_CVT_11(ecdA_SF6));
  }
  if ( DetAvgCt2 > 0 ) {
  		ecdA_F11 = ecd_sum2/DetAvgCt2;
  		ecdA_F11save = ecdA_F11;
  		DetAvgCt2 = 0;
  		ecd_sum2 = 0;
  		DetAvgOffline2 = 0;
  	} 
  	else if (( ecdA_F11save > 0 ) && ( DetAvgOffline2 < 1 )) {
  		DetAvgOffline2++;
  		ecdA_F11 = ecdA_F11save;
  	}
  	else {
  		ecdA_F11 = ECDOFFLINE;
  		ecdA_F11save = 0;
  	} {
    display_(0,15,42,
    
    GC_Freq,ecdA_F11,_CVT_11(ecdA_F11));
  }
  if ( DetAvgCt3 > 0 ) {
  		ecdA_CO = ecd_sum3/DetAvgCt3;
  		ecdA_COsave = ecdA_CO;
  		DetAvgCt3 = 0;
  		ecd_sum3 = 0;
  		DetAvgOffline3 = 0;
  	} 
  	else if (( ecdA_COsave > 0 ) && ( DetAvgOffline3 < 1 )) {
  		DetAvgOffline3++;
  		ecdA_CO = ecdA_COsave;
  	}
  	else {
  		ecdA_CO = ECDOFFLINE;
  		ecdA_COsave = 0;
  	} {
    display_(0,25,7,
    
    GC_Freq,ecdA_CO,_CVT_11(ecdA_CO));
  }
  if ( DetAvgCt4 > 0 ) {
  		ecdA_PAN = ecd_sum4/DetAvgCt4;
  		ecdA_PANsave = ecdA_PAN;
  		DetAvgCt4 = 0;
  		ecd_sum4 = 0;
  		DetAvgOffline4 = 0;
  	} 
  	else if (( ecdA_PANsave > 0 ) && ( DetAvgOffline4 < 1 )) {
  		DetAvgOffline4++;
  		ecdA_PAN = ecdA_PANsave;
  	}
  	else {
  		ecdA_PAN = ECDOFFLINE;
  		ecdA_PANsave = 0;
  	} {
    display_(0,25,42,
    
    GC_Freq,ecdA_PAN,_CVT_11(ecdA_PAN));
  }
  }
  {
   	++CUMSEC; {
    display_(0,2,14,
    
    
    
    
    ULONG,CUMSEC,_CVT_24(CUMSEC));
    display_(2,11,14,
    
    
    
    
    ULONG,CUMSEC,_CVT_24(CUMSEC));
  }
  }
  {
  	if ( MSchanAvg[0] > 0 ) {
  		msdA_0 = msd_sum[0]/MSchanAvg[0];
  		MSchanAvg[0] = msd_sum[0] = 0;
  	} else {
  		msdA_0 = MSDOFFLINE;
  	} {
    display_(2,3,10,
    
    MSD_DataType,msdA_0,_CVT_8(msdA_0));
  }
  if ( MSchanAvg[1] > 0 ) {
  		msdA_1 = msd_sum[1]/MSchanAvg[1];
  		MSchanAvg[1] = msd_sum[1] = 0;
  	} else {
  		msdA_1 = MSDOFFLINE;
  	} {
    display_(2,4,10,
    
    MSD_DataType,msdA_1,_CVT_8(msdA_1));
  }
  if ( MSchanAvg[2] > 0 ) {
  		msdA_2 = msd_sum[2]/MSchanAvg[2];
  		MSchanAvg[2] = msd_sum[2] = 0;
  	} else {
  		msdA_2 = MSDOFFLINE;
  	} {
    display_(2,5,10,
    
    MSD_DataType,msdA_2,_CVT_8(msdA_2));
  }
  if ( MSchanAvg[3] > 0 ) {
  		msdA_3 = msd_sum[3]/MSchanAvg[3];
  		MSchanAvg[3] = msd_sum[3] = 0;
  	} else {
  		msdA_3 = MSDOFFLINE;
  	} {
    display_(2,6,10,
    
    MSD_DataType,msdA_3,_CVT_8(msdA_3));
  }
  if ( MSchanAvg[4] > 0 ) {
  		msdA_4 = msd_sum[4]/MSchanAvg[4];
  		MSchanAvg[4] = msd_sum[4] = 0;
  	} else {
  		msdA_4 = MSDOFFLINE;
  	} {
    display_(2,3,30,
    
    MSD_DataType,msdA_4,_CVT_8(msdA_4));
  }
  if ( MSchanAvg[5] > 0 ) {
  		msdA_5 = msd_sum[5]/MSchanAvg[5];
  		MSchanAvg[5] = msd_sum[5] = 0;
  	} else {
  		msdA_5 = MSDOFFLINE;
  	} {
    display_(2,4,30,
    
    MSD_DataType,msdA_5,_CVT_8(msdA_5));
  }
  if ( MSchanAvg[6] > 0 ) {
  		msdA_6 = msd_sum[6]/MSchanAvg[6];
  		MSchanAvg[6] = msd_sum[6] = 0;
  	} else {
  		msdA_6 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[7] > 0 ) {
  		msdA_7 = msd_sum[7]/MSchanAvg[7];
  		MSchanAvg[7] = msd_sum[7] = 0;
  	} else {
  		msdA_7 = MSDOFFLINE;
  	}
  
  }
  {if (!(V7)) {
    { 
    	MSDchromtime += 1; 
    	InjectingInc_MSD = 0; {
      display_(2,10,14,
      
      ULONG,MSDchromtime,_CVT_24(MSDchromtime));
    }
    }
  }if (!(V8)) {
    { 
    	if ( InjectingInc_MSD == 0 ) {
    		MSDchromtime = 1; 
    		InjectingInc_MSD = 1;
    	} else 
    		MSDchromtime += 1; {
      display_(2,10,14,
      
      ULONG,MSDchromtime,_CVT_24(MSDchromtime));
    }
    }
  }
  }
  {
  	if (maycomm_proxy != 0)  Trigger ( maycomm_proxy );
  }
}

static void EF2_1(void) {
  if (!(V3)) {
    {
    	if (home->U0.GC_Ctr_SF6 >= 0) {
    		ecd_sum1 += home->U0.GC_Ctr_SF6;
    		DetAvgCt1++;
    		ecdSF6x += ELECRATE;
    	} 
    	if (GC_Ctr_F11 >= 0) {
    		ecd_sum2 += GC_Ctr_F11;
    		DetAvgCt2++;
    		ecdF11x += ELECRATE;
    	}
    	if (GC_Ctr_CO >= 0) {
    		ecd_sum3 += GC_Ctr_CO;
    		DetAvgCt3++;
    		ecdCOx += ELECRATE;
    	}
    	if (GC_Ctr_PAN >= 0) {
    		ecd_sum4 += GC_Ctr_PAN;
    		DetAvgCt4++;
    		ecdPANx += ELECRATE;
    	}
    }
  }
  if (!(V12)) {
    {
    
    	if ( GC_Ctr_F11 != ECDOFFLINE ) {
    		integrate( 0, GC_Ctr_F11, F11int, CHROMtime, old_ssvfold );
    	}
    
    	if ( home->U0.GC_Ctr_SF6 != ECDOFFLINE ) {
    		integrate( 0, home->U0.GC_Ctr_SF6, N2Oint, CHROMtime, old_ssv1min );
    	}
    
    	if ( home->U0.GC_Ctr_SF6 != ECDOFFLINE ) {
    		integrate( 0, home->U0.GC_Ctr_SF6, SF6int, CHROMtime, old_ssv1min );
    	}
    
    	if (( GC_Ctr_CO != ECDOFFLINE ) && ( !firsthalf )) {
    		integrate( 0, GC_Ctr_CO, CH4int, CHROMtime, old_ssvfold );
    	}
    
    }
  }
  if ( home->U0.GC_Ctr_SF6 >= 0 )if (!(V13)) {
    {
      	rtg_report( chromSF6_rtg[ chromSF6_rtginc ], ecdSF6x, home->U0.GC_Ctr_SF6 );
    }
  }
}

static void EF8_1(void) {
  EF2_1();
  display_(2,28,49,
  	 Bit_Off_On,home->U13.trap1heat,Off_On_text[home->U13.trap1heat]);
  display_(2,32,49, 
  	 Bit_Off_On,home->U13.trap2heat,Off_On_text[home->U13.trap2heat]);
}

static void BF16_1(void) {
  EF8_1();
  display_(0,1,62,
  
  	 Bit_HI_LO,home->U17.faildummy,HI_LO_text[home->U17.faildummy]);
}

static void BF32_1(void) {
  BF16_1();
  if (!(V20)) {
    {
      rtg_report( ecdMSprs_rtg[ ecdMSprs_rtginc ], dtime() - Injection_rtgbt, home->U11.PresE_5);
    }
  }
  display_(2,19,8,			
  	 adT,home->U11.PresE_5,_CVT_23(home->U11.PresE_5));
  display_(2,19,21,
  	 vdc_chan,home->U7.VoltE_5,_CVT_19(home->U7.VoltE_5));
  display_(2,23,12,			
  	 adT,home->U9.PresBP_5,_CVT_23(home->U9.PresBP_5));
  display_(2,23,24,
  	 vdc_chan,home->U9.VoltBP_5,_CVT_19(home->U9.VoltBP_5));
  display_(2,26,20,
  
  	
  	 adT,home->U0.PresMS1,_CVT_23(home->U0.PresMS1));
  display_(2,26,33,			
  	 vdc_chan,home->U9.VoltMS1,_CVT_19(home->U9.VoltMS1));
  display_(2,29,20,			
  	 adT,home->U1.PresMS2,_CVT_23(home->U1.PresMS2));
  display_(2,29,33,
  	 vdc_chan,home->U9.VoltMS2,_CVT_19(home->U9.VoltMS2));
}

static void BF32_3(void) {
  EF2_1();
  if (!(V18)) {
    {
      rtg_report( ecdCOprs_rtg[ ecdCOprs_rtginc ], dtime() - Injection_rtgbt, home->U0.PresE_CO);
    }
  }
  display_(0,5,24,
  	 vdc_chan,home->U0.VoltE_CO,_CVT_19(home->U0.VoltE_CO));
  display_(0,28,7,
  	
  	 adT_flow,home->U1.FlowM_CO,_CVT_21(home->U1.FlowM_CO));
  display_(0,28,20,
  	 vdc_chan,home->U0.VoltM_CO,_CVT_19(home->U0.VoltM_CO));
  display_(0,29,7,
  	 adT_flow,home->U3.FlowB_CO,_CVT_21(home->U3.FlowB_CO));
  display_(0,29,20,
  	 vdc_chan,home->U0.VoltB_CO,_CVT_19(home->U0.VoltB_CO));
  display_(0,30,7,
  	 adT,home->U1.PresBP_CO,_CVT_23(home->U1.PresBP_CO));
  display_(0,30,20,
  	 vdc_chan,home->U1.VoltBP_CO,_CVT_19(home->U1.VoltBP_CO));
  display_(0,31,7,
  	 adT,home->U0.PresE_CO,_CVT_23(home->U0.PresE_CO));
  display_(0,31,20,
  	 vdc_chan,home->U0.VoltE_CO,_CVT_19(home->U0.VoltE_CO));
  display_(2,28,20,
  
  	
  	 adT,home->U3.ColT_MS1,_CVT_23(home->U3.ColT_MS1));
  display_(2,31,20,
  	 adT,home->U3.ColT_MS2,_CVT_23(home->U3.ColT_MS2));
}

static void BF32_5(void) {
  maycX = home->U25.maycX; {
    V22 &= ~0x2;
    V21 &= ~0x2;
  }
  EF2_1();
  maycX++;
  {if (!(V9)) {
    { VSET_3_(1); }
  }
  
  	if ( maycX >= 120 ) { 
  		maycX = 0; VSET_3_(2);
  	}
  }
  display_(0,18,42,
  
  	 adT_flow,home->U5.FlowM_F11,_CVT_21(home->U5.FlowM_F11));
  display_(0,18,55,
  	 vdc_chan,home->U3.VoltM_F11,_CVT_19(home->U3.VoltM_F11));
  display_(0,19,42,
  	 adT_flow,home->U7.FlowB_F11,_CVT_21(home->U7.FlowB_F11));
  display_(0,19,55,
  	 vdc_chan,home->U3.VoltB_F11,_CVT_19(home->U3.VoltB_F11));
  display_(0,20,42,
  	 adT,home->U5.PresBP_F11,_CVT_23(home->U5.PresBP_F11));
  display_(0,20,55,
  	 vdc_chan,home->U5.VoltBP_F11,_CVT_19(home->U5.VoltBP_F11));
  display_(0,21,42,
  	 adT,home->U3.PresE_F11,_CVT_23(home->U3.PresE_F11));
  display_(0,21,55,
  	 vdc_chan,home->U1.VoltE_F11,_CVT_19(home->U1.VoltE_F11));
  display_(0,27,42,
  	 adT,home->U5.ColT_PAN,_CVT_23(home->U5.ColT_PAN));
}

static void BF32_7(void) {
  EF2_1();
  if (!(V19)) {
    {
      rtg_report( ecdPANprs_rtg[ ecdPANprs_rtginc ], dtime() - Injection_rtgbt, home->U7.PresE_PAN);
    }
  }
  display_(0,10,25, 		
  	 adT_flow,home->U5.FlowSrc_PAN,_CVT_21(home->U5.FlowSrc_PAN));
  display_(0,10,32,			
  	 adT,home->U7.PresSrc_PAN,_CVT_23(home->U7.PresSrc_PAN));
  display_(0,28,42,
  
  	 adT,home->U7.Pres1_PAN,_CVT_23(home->U7.Pres1_PAN));
  display_(0,28,55,
  	 vdc_chan,home->U5.VoltM_PAN,_CVT_19(home->U5.VoltM_PAN));
  display_(0,29,42,			
  	 adT,home->U9.Pres2_PAN,_CVT_23(home->U9.Pres2_PAN));
  display_(0,29,55,
  	 vdc_chan,home->U7.VoltB_PAN,_CVT_19(home->U7.VoltB_PAN));
  display_(0,30,42, 
  	 adT,home->U7.PresE_PAN,_CVT_23(home->U7.PresE_PAN));
  display_(0,30,55,
  	 vdc_chan,home->U3.VoltE_PAN,_CVT_19(home->U3.VoltE_PAN));
  display_(1,10,42,
  	 vdc_pow,home->U17.Pow_m15,_CVT_17(home->U17.Pow_m15));
  display_(1,11,42,
  	 vdc_pow,home->U15.Pow_p12,_CVT_17(home->U15.Pow_p12));
}

static void BF32_9(void) {
  PresE_SF6 = home->U3.PresE_SF6;
  V10 &= ~0x2;
  EF8_1();
  if (!(V17)) {
    {
      rtg_report( ecdSF6prs_rtg[ ecdSF6prs_rtginc ], dtime() - Injection_rtgbt, PresE_SF6);
    }
  }
  display_(0,19,7,
  
  	 adT_flow,home->U0.FlowM_SF6,_CVT_21(home->U0.FlowM_SF6));
  display_(0,19,20,
  	 vdc_chan,home->U1.VoltM_SF6,_CVT_19(home->U1.VoltM_SF6));
  display_(0,20,7,
  	 adT_flow,home->U3.FlowB_SF6,_CVT_21(home->U3.FlowB_SF6));
  display_(0,20,20,
  	 vdc_chan,home->U1.VoltB_SF6,_CVT_19(home->U1.VoltB_SF6));
  display_(0,21,7,
  	 adT,home->U5.PresBP_SF6,_CVT_23(home->U5.PresBP_SF6));
  display_(0,21,20,
  	 vdc_chan,home->U1.VoltBP_SF6,_CVT_19(home->U1.VoltBP_SF6));
  display_(0,22,7,
  	 adT,PresE_SF6,_CVT_23(PresE_SF6));
  display_(0,22,20,
  	 vdc_chan,home->U3.VoltE_SF6,_CVT_19(home->U3.VoltE_SF6));
  display_(1,9,42,
  	 vdc_pow,home->U17.Pow_p15,_CVT_17(home->U17.Pow_p15));
}

static void BF32_11(void) {
  tdlP = home->U23.tdlP;
  tdlsH2O = home->U35.tdlsH2O;
  tdllH2O = home->U35.tdllH2O;
  V10 &= ~0x1;
  EF2_1();
  if ( tdlP > 0 ) {if (!(V21)) {
    {
      	rtg_report( TDLshort_rtg[ TDLshort_rtginc ], maycX, tdlsH2O );
    }
  }if (!(V22)) {
    {
      	rtg_report( TDLlong_rtg[ TDLlong_rtginc ] , maycX, tdllH2O );
    }
  }
  }
  display_(1,7,42,
  	 vdc_pow,home->U15.Pow_p15pel1,_CVT_17(home->U15.Pow_p15pel1));
  display_(1,8,42,
  	 vdc_pow,home->U13.Pow_p15pel2,_CVT_17(home->U13.Pow_p15pel2));
  display_(1,23,11, 
   tdlfloas,home->U33.tdlT,_CVT_3(home->U33.tdlT));
  display_(1,24,11,
  
  
   tdlfloas,tdlP,_CVT_3(tdlP));
  display_(1,23,36, 
   tdlfloat,tdlsH2O,_CVT_5(tdlsH2O));
  display_(1,24,38,	
   tdlint6,home->U35.tdlsAmp,SS_6_224_d_0(home->U35.tdlsAmp));
  display_(1,25,38,
   tdlint6,home->U35.tdlsPow,SS_6_224_d_0(home->U35.tdlsPow));
  display_(1,26,38,
   tdlint6,home->U35.tdlsPos,SS_6_224_d_0(home->U35.tdlsPos));
  display_(1,27,38,
   tdlint6,home->U35.tdlsZer,SS_6_224_d_0(home->U35.tdlsZer));
  display_(1,23,58,
   tdlfloat,tdllH2O,_CVT_5(tdllH2O));
  display_(1,24,60,	
   tdlint6,home->U33.tdllAmp,SS_6_224_d_0(home->U33.tdllAmp));
  display_(1,25,60,
   tdlint6,home->U33.tdllPow,SS_6_224_d_0(home->U33.tdllPow));
  display_(1,26,60,
   tdlint6,home->U29.tdllPos,SS_6_224_d_0(home->U29.tdllPos));
  display_(1,27,60,
   tdlint6,home->U29.tdllZer,SS_6_224_d_0(home->U29.tdllZer));
}

static void BF32_13(void) {
  EF2_1();
  if (!(V11)) {
    {
    
    	old_ssvfold = old_ssv1min;
    	old_ssv1min = home->U23.ssv1;
    
    }
  }
  display_(0,5,42,
  	 adT,home->U13.Flow_Packsl,_CVT_23(home->U13.Flow_Packsl));
  display_(0,6,42,
  	 adT,home->U13.Flow_PANsl,_CVT_23(home->U13.Flow_PANsl));
  display_(0,8,10,
  
   valvT,home->U23.ssv1,_CVT_10(home->U23.ssv1));
  display_(0,8,17,
   valvT,home->U23.ssv2,_CVT_10(home->U23.ssv2));
  display_(0,14,25,
   valvetext,home->U23.valv_SF6,Load_Inject_text[home->U23.valv_SF6]);
  display_(0,14,59,
   valvetext,home->U23.valv_F11,Load_Inject_text[home->U23.valv_F11]);
  display_(0,24,24,
   valvetext,home->U17.valv_CO,Load_Inject_text[home->U17.valv_CO]);
  display_(0,24,59,
   valvetext,home->U29.valv_PAN,Load_Inject_text[home->U29.valv_PAN]);
  display_(1,3,42,
  
  	 vdc_pow,home->U11.Pow_p28pri,_CVT_17(home->U11.Pow_p28pri));
  display_(1,5,42,
  	 vdc_pow,home->U17.Pow_p24gsv,_CVT_17(home->U17.Pow_p24gsv));
  display_(1,6,42,
  	 vdc_pow,home->U19.Pow_p24ms,_CVT_17(home->U19.Pow_p24ms));
  display_(2,14,11,
   valvT,home->U23.ssv2,_CVT_10(home->U23.ssv2));
  display_(2,14,29,
  
   valvT,home->U23.ssv1,_CVT_10(home->U23.ssv1));
  display_(2,16,11,
   valveMS1text,home->U17.valv_MS1,Inj2_Inj1_text[home->U17.valv_MS1]);
  display_(2,16,29,
   valveMS2text,home->U17.valv_MS2,Inj2_Inj1_text[home->U17.valv_MS2]);
  display_(2,20,8,
  
  	
  	 adT,home->U13.Flow_MSsl,_CVT_23(home->U13.Flow_MSsl));
}

static void BF32_15(void) {
  EF2_1();
  display_(0,4,16,
  	 adT,home->U11.Pres_Inlet,_CVT_23(home->U11.Pres_Inlet));
  display_(0,5,16,
  
  
  	 adT,home->U11.Pres_SL,_CVT_23(home->U11.Pres_SL));
  display_(0,6,16,	
  	 adT,home->U5.PresBP_PAN,_CVT_23(home->U5.PresBP_PAN));
  display_(1,4,42,
  	 vdc_pow,home->U11.Pow_p28sec,_CVT_17(home->U11.Pow_p28sec));
  display_(1,12,42,
  	 vdc_pow,home->U15.Pow_p5,_CVT_17(home->U15.Pow_p5));
  display_(1,4,56,
  	 adT,home->U5.PresH_N2,_CVT_23(home->U5.PresH_N2));
  display_(1,5,56,
  	 adT,home->U7.PresH_He,_CVT_23(home->U7.PresH_He));
  display_(1,6,56,
  	 adT,home->U15.PresH_Cal1,_CVT_23(home->U15.PresH_Cal1));
  display_(1,7,56,
  	 adT,home->U15.PresH_Cal2,_CVT_23(home->U15.PresH_Cal2));
  display_(1,11,56,
  
  	 adT,home->U11.PresH_CO2,_CVT_23(home->U11.PresH_CO2));
}

static void BF32_17(void) {
  BF16_1();
  display_(1,5,64,
  	 adT,home->U7.PresL_He,_CVT_23(home->U7.PresL_He));
  display_(1,6,64,
  	 adT,home->U17.PresL_Cal1,_CVT_23(home->U17.PresL_Cal1));
  display_(1,7,64,
  	 adT,home->U13.PresL_Cal2,_CVT_23(home->U13.PresL_Cal2));
  display_(1,8,56,
  	 adT,home->U13.PresH_PAN,_CVT_23(home->U13.PresH_PAN));
  display_(1,9,56,
  	 adT,home->U15.PresH_ZA,_CVT_23(home->U15.PresH_ZA));
  display_(1,10,56,
  	 adT,home->U13.PresH_N2O,_CVT_23(home->U13.PresH_N2O));
  display_(1,11,64,
  
  	 adT,home->U9.PresL_CO2,_CVT_23(home->U9.PresL_CO2));
}

static void BF32_19(void) {
  EF2_1();
  if (!(V10)) {
    {
    //	P = ((PresE_SF6) - 30);
        P = (tdlP);
    	home->U33.tdlbH2O = tdllH2O / ( 1.15 - 0.0008123 * P + 5.283e-7 * P*P );
    //	home->U33.tdlbH2O = tdllH2O / ( 1.135 - 0.000757 * P + 5.372e-7 * P*P );
    	home->U33.tdlbH2O = (tdllH2O * 1.62) -2.55;
    	
    	if ( tdllH2O > USELONGPATH ) home->U33.tdlbH2O = (tdlsH2O - OffsetShortPath)*1.55;
    }
  }
  display_(1,5,18,
  	 adT,home->U11.Temp_COsl,_CVT_23(home->U11.Temp_COsl));
  display_(1,8,18,
  	 adT,home->U9.Temp_elect,_CVT_23(home->U9.Temp_elect));
  display_(1,4,64,
  	 adT,home->U7.PresL_N2,_CVT_23(home->U7.PresL_N2));
  display_(1,8,64,
  	 adT,home->U15.PresL_PAN,_CVT_23(home->U15.PresL_PAN));
  display_(1,9,64,
  	 adT,home->U15.PresL_ZA,_CVT_23(home->U15.PresL_ZA));
  display_(1,10,64,
  	 adT,home->U11.PresL_N2O,_CVT_23(home->U11.PresL_N2O));
  display_(1,27,11,
  
   tdlfloat,home->U33.tdlbH2O,_CVT_5(home->U33.tdlbH2O));
  display_(2,27,20,
  	 dacMSpr,home->U11.PresMS1sp,_CVT_15(home->U11.PresMS1sp));
  display_(2,30,20,
  	 dacMSpr,home->U11.PresMS2sp,_CVT_15(home->U11.PresMS2sp));
}

static void BF32_21(void) {
  EF2_1();
  display_(1,3,18,
  	 adT,home->U15.Temp_SF6sl,_CVT_23(home->U15.Temp_SF6sl));
  display_(1,4,18,
  	
  	 adT,home->U9.Temp_F11sl,_CVT_23(home->U9.Temp_F11sl));
  display_(1,6,18,
  	 adT,home->U17.Temp_PANsl,_CVT_23(home->U17.Temp_PANsl));
  display_(1,7,18,
  	 adT,home->U17.Temp_GSVbo,_CVT_23(home->U17.Temp_GSVbo));
  display_(1,9,18,
  	 adT,home->U13.Temp_stack,_CVT_23(home->U13.Temp_stack));
  display_(1,10,18,
  	 adT,home->U17.Temp_Ipump,_CVT_23(home->U17.Temp_Ipump));
  display_(1,11,18,
  	 adT,home->U19.Temp_PANsrc,_CVT_23(home->U19.Temp_PANsrc));
  display_(1,12,18,	
  	 adT,home->U17.Temp_PANlmp,_CVT_23(home->U17.Temp_PANlmp));
  display_(1,13,18,	
  	 adT,home->U13.Temp_GasBot,_CVT_23(home->U13.Temp_GasBot));
  display_(2,27,49,
  	 adT,home->U1.Trap1_re,_CVT_23(home->U1.Trap1_re));
}

static void BF32_23(void) {
  EF2_1();
  { ITXFileNum = home->U0.CurrInj * 1000 + home->U0.CurrFile;
  }
  display_(0,1,32,
   UINT,home->U0.CurrInj,US_5_0_u_0(home->U0.CurrInj));
  display_(0,6,24,
  	 vdc_chan,home->U7.VoltBP_PAN,_CVT_19(home->U7.VoltBP_PAN));
  display_(0,16,42,
   OmegaT,home->U19.F11_ECD,_CVT_13(home->U19.F11_ECD));
  display_(0,16,55,
   OmegaTsp,home->U19.F11_ECD_Sp,_CVT_12(home->U19.F11_ECD_Sp));
  display_(0,17,42,
  
   OmegaT,home->U21.F11_Col,_CVT_13(home->U21.F11_Col));
  display_(0,17,55,
  
   OmegaTsp,home->U21.F11_Col_Sp,_CVT_12(home->U21.F11_Col_Sp));
  display_(0,26,7,
   OmegaT,home->U23.CO_ECD,_CVT_13(home->U23.CO_ECD));
  display_(0,26,20,
   OmegaTsp,home->U23.CO_ECD_Sp,_CVT_12(home->U23.CO_ECD_Sp));
  display_(0,27,7,
   OmegaT,home->U21.CO_Col,_CVT_13(home->U21.CO_Col));
  display_(0,27,20,
   OmegaTsp,home->U21.CO_Col_Sp,_CVT_12(home->U21.CO_Col_Sp));
  display_(1,17,12,
   OmegaT,home->U19.F11_ECD,_CVT_13(home->U19.F11_ECD));
  display_(1,17,20,
   OmegaTsp,home->U19.F11_ECD_Sp,_CVT_12(home->U19.F11_ECD_Sp));
  display_(1,17,33,
  
   OmegaT,home->U21.F11_Col,_CVT_13(home->U21.F11_Col));
  display_(1,17,41,
  
   OmegaTsp,home->U21.F11_Col_Sp,_CVT_12(home->U21.F11_Col_Sp));
  display_(1,18,12,
   OmegaT,home->U23.CO_ECD,_CVT_13(home->U23.CO_ECD));
  display_(1,18,20,
   OmegaTsp,home->U23.CO_ECD_Sp,_CVT_12(home->U23.CO_ECD_Sp));
  display_(1,18,33,
   OmegaT,home->U21.CO_Col,_CVT_13(home->U21.CO_Col));
  display_(1,18,41,
   OmegaTsp,home->U21.CO_Col_Sp,_CVT_12(home->U21.CO_Col_Sp));
  display_(2,10,35,
  
  
  
   UINT,home->U19.CurrInj_MSD,US_5_0_u_0(home->U19.CurrInj_MSD));
  display_(2,27,62,
  
  	
  	 adT,home->U5.Trap1_set,_CVT_23(home->U5.Trap1_set));
  display_(2,31,49,
  	 adT,home->U9.Trap2_re,_CVT_23(home->U9.Trap2_re));
  display_(2,31,62,
  	 adT,home->U9.Trap2_set,_CVT_23(home->U9.Trap2_set));
}

static void BF32_25(void) {
  EF8_1();
  display_(0,8,26,
  
  	 Bit_Air_Cal,home->U19.PANsol1,Air_Cal_text[home->U19.PANsol1]);
  display_(0,9,29,
  	 Bit_Off_On,home->U19.PANlamp,Off_On_text[home->U19.PANlamp]);
  display_(0,9,35,
  	 Bit_Off_On,home->U19.PANflowCont,Off_On_text[home->U19.PANflowCont]);
  display_(0,9,41,
  	 Bit_Off_On,home->U21.PANsol3,Off_On_text[home->U21.PANsol3]);
  display_(0,2,62,
  	 Bit_HI_LO,home->U0.pilotTrip,HI_LO_text[home->U0.pilotTrip]);
  display_(0,6,56,
  	 Bit_Cl_Op,home->U21.PANsol2,Cl_Op_text[home->U21.PANsol2]);
  display_(0,6,62,
  	 Bit_Op_Cl,home->U21.PANsol4,Op_Cl_text[home->U21.PANsol4]);
  display_(0,7,63,
  	 Bit_Cl_Op,home->U19.PANflsh,Cl_Op_text[home->U19.PANflsh]);
  display_(0,16,7,
   OmegaT,home->U21.SF6_ECD,_CVT_13(home->U21.SF6_ECD));
  display_(0,16,20,
   OmegaTsp,home->U21.SF6_ECD_Sp,_CVT_12(home->U21.SF6_ECD_Sp));
  display_(0,17,7,
   OmegaT,home->U23.SF6_Col,_CVT_13(home->U23.SF6_Col));
  display_(0,17,20,
   OmegaTsp,home->U23.SF6_Col_Sp,_CVT_12(home->U23.SF6_Col_Sp));
  display_(0,26,42,
   OmegaT,home->U21.PAN_ECD,_CVT_13(home->U21.PAN_ECD));
  display_(0,26,55,
   OmegaTsp,home->U21.PAN_ECD_Sp,_CVT_12(home->U21.PAN_ECD_Sp));
  display_(1,16,12,
   OmegaT,home->U21.SF6_ECD,_CVT_13(home->U21.SF6_ECD));
  display_(1,16,20,
   OmegaTsp,home->U21.SF6_ECD_Sp,_CVT_12(home->U21.SF6_ECD_Sp));
  display_(1,16,33,
   OmegaT,home->U23.SF6_Col,_CVT_13(home->U23.SF6_Col));
  display_(1,16,41,
   OmegaTsp,home->U23.SF6_Col_Sp,_CVT_12(home->U23.SF6_Col_Sp));
  display_(1,19,12,
   OmegaT,home->U21.PAN_ECD,_CVT_13(home->U21.PAN_ECD));
  display_(1,19,20,
   OmegaTsp,home->U21.PAN_ECD_Sp,_CVT_12(home->U21.PAN_ECD_Sp));
  display_(2,11,37,
   WinNum,home->U19.IonWinNum,_CVT_9(home->U19.IonWinNum));
  display_(2,28,67,
  	 Bit_Off_On,home->U0.pelt1State,Off_On_text[home->U0.pelt1State]);
  display_(2,32,67,
  	 Bit_Off_On,home->U19.pelt2State,Off_On_text[home->U19.pelt2State]);
}

static void BF32_27(void) {
  EF2_1();
  if (!(V0)) {
    {
      if ( home->U19.GCstate == 2 ) VSET_0_(3);
    }
  }
    else {
      if ( home->U19.GCstate == 1 ) VSET_0_(2);
      if ( home->U19.GCstate == 0 ) VSET_0_(1);
    }
  {
  		MSDstateS = home->U19.MSDstate;
  	}
  if (!(V6)) {
    {
      if ( home->U19.MSDstate == 2 ) VSET_2_(3);
    }
  }
    else {
      if ( home->U19.MSDstate == 1 ) VSET_2_(2);
      else if ( home->U19.MSDstate == 0 ) VSET_2_(1);
    }
  display_(0,5,56,
  	 Bit_Cl_Op,home->U19.SLoopIN,Cl_Op_text[home->U19.SLoopIN]);
  display_(0,5,62,
  	 Bit_Cl_Op,home->U19.SLoopOUT,Cl_Op_text[home->U19.SLoopOUT]);
  display_(0,18,7,
   OmegaT,home->U15.SF6_Post,_CVT_13(home->U15.SF6_Post));
  display_(0,18,20,
   OmegaTsp,home->U15.SF6_Post_Sp,_CVT_12(home->U15.SF6_Post_Sp));
  display_(1,16,54,
   OmegaT,home->U15.SF6_Post,_CVT_13(home->U15.SF6_Post));
  display_(1,16,62,
   OmegaTsp,home->U15.SF6_Post_Sp,_CVT_12(home->U15.SF6_Post_Sp));
  display_(1,20,18,
   OmegaT,home->U19.Trap1_CB,_CVT_13(home->U19.Trap1_CB));
  display_(1,20,26,
   OmegaTsp,home->U21.Trap1_CB_Sp,_CVT_12(home->U21.Trap1_CB_Sp));
  display_(1,20,38,
   OmegaT,home->U23.Trap2_CB,_CVT_13(home->U23.Trap2_CB));
  display_(1,20,46,
   OmegaTsp,home->U23.Trap2_CB_Sp,_CVT_12(home->U23.Trap2_CB_Sp));
  display_(2,15,12, 
   UCHAR,home->U19.MSDstate,_CVT_25[home->U19.MSDstate]);
  display_(2,21,16,
  	 Bit_Op_Cl,home->U0.SLoopMSout,Op_Cl_text[home->U0.SLoopMSout]);
  display_(2,26,49,
   OmegaT,home->U19.Trap1_CB,_CVT_13(home->U19.Trap1_CB));
  display_(2,28,56,
  	 Bit_Off_On,home->U21.trap1relay,Off_On_text[home->U21.trap1relay]);
  display_(2,30,49,
   OmegaT,home->U23.Trap2_CB,_CVT_13(home->U23.Trap2_CB));
  display_(2,32,56,
  	 Bit_Off_On,home->U19.trap2relay,Off_On_text[home->U19.trap2relay]);
}

static void BF64_29(void) {
  EF2_1();
  display_(2,3,65,
   MSDdouble,home->U33.msdTURBOPCT,_CVT_7(home->U33.msdTURBOPCT));
  display_(2,7,65,
   MSDdouble,home->U31.msdSRCTEMP,_CVT_7(home->U31.msdSRCTEMP));
  display_(2,8,65,
   MSDdouble,home->U31.msdQUAD,_CVT_7(home->U31.msdQUAD));
  display_(2,21,65,
   MSDdouble,home->U33.msdMASG,_CVT_7(home->U33.msdMASG));
  display_(2,22,65,
   MSDdouble,home->U27.msdMASO,_CVT_7(home->U27.msdMASO));
}

static void BF64_31(void) {
  EF2_1();
  display_(2,5,65,
   MSDdouble,home->U31.msdHEDEN,_CVT_7(home->U31.msdHEDEN));
  display_(2,6,65,
   MSDdouble,home->U25.msdEMUL,_CVT_7(home->U25.msdEMUL));
  display_(2,15,65,
   MSDdouble,home->U29.msdENTO,_CVT_7(home->U29.msdENTO));
  display_(2,19,65,
   MSDdouble,home->U29.msdMMW,_CVT_7(home->U29.msdMMW));
  display_(2,23,65,
   MSDdouble,home->U31.msdCAL,_CVT_7(home->U31.msdCAL));
}

static void BF64_61(void) {
  EF2_1();
  display_(2,10,65,
   MSDdouble,home->U23.msdFSEL,_CVT_7(home->U23.msdFSEL));
  display_(2,13,65,
   MSDdouble,home->U29.msdIFOC,_CVT_7(home->U29.msdIFOC));
  display_(2,14,65,
   MSDdouble,home->U29.msdENT,_CVT_7(home->U29.msdENT));
  display_(2,17,65,
   MSDdouble,home->U27.msdAMUG,_CVT_7(home->U27.msdAMUG));
  display_(2,18,65,
   MSDdouble,home->U27.msdAMUO,_CVT_7(home->U27.msdAMUO));
}

static void BF64_63(void) {
  EF2_1();
  display_(2,4,65,
  
   MSDdouble,home->U25.msdECUR,_CVT_7(home->U25.msdECUR));
  display_(2,11,65,
   MSDdouble,home->U27.msdREP,_CVT_7(home->U27.msdREP));
  display_(2,12,65,
   MSDdouble,home->U21.msdEEGY,_CVT_7(home->U21.msdEEGY));
  display_(2,20,65,
   MSDdouble,home->U27.msdIPOL,_CVT_7(home->U27.msdIPOL));
}

static void (*efuncs[64])() = {
  BF32_0,
  BF32_1,
  BF2_0,
  BF32_3,
  BF2_0,
  BF32_5,
  BF2_0,
  BF32_7,
  BF2_0,
  BF32_9,
  BF2_0,
  BF32_11,
  BF2_0,
  BF32_13,
  BF2_0,
  BF32_15,
  BF2_0,
  BF32_17,
  BF2_0,
  BF32_19,
  BF2_0,
  BF32_21,
  BF2_0,
  BF32_23,
  BF2_0,
  BF32_25,
  BF2_0,
  BF32_27,
  BF2_0,
  BF64_29,
  BF2_0,
  BF64_31,
  BF32_0,
  BF32_1,
  BF2_0,
  BF32_3,
  BF2_0,
  BF32_5,
  BF2_0,
  BF32_7,
  BF2_0,
  BF32_9,
  BF2_0,
  BF32_11,
  BF2_0,
  BF32_13,
  BF2_0,
  BF32_15,
  BF2_0,
  BF32_17,
  BF2_0,
  BF32_19,
  BF2_0,
  BF32_21,
  BF2_0,
  BF32_23,
  BF2_0,
  BF32_25,
  BF2_0,
  BF32_27,
  BF2_0,
  BF64_61,
  BF2_0,
  BF64_63
};

static void IVF2_0(void) { {
    V12 |= 0x4;
    V3 |= 0x1;
  }
}
static void IVF32_5(void) { {
    V22 |= 0x2;
    V21 |= 0x2;
  }
}
static void IVF32_9(void) {
  V10 |= 0x2;
}
static void IVF32_11(void) {
  V10 |= 0x1;
}
#define IVFUNCS
static void (*ivfuncs[64])() = {
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_5,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_9,
  IVF2_0,
  IVF32_11,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_5,
  IVF2_0,
  nullfunc,
  IVF2_0,
  IVF32_9,
  IVF2_0,
  IVF32_11,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc,
  IVF2_0,
  nullfunc
};

static void nullfunc(void){}
#define TRN 320
#define TRD 1
#define LOWLIM (-2880)
#define HIGHLIM (2880)
#define NBROW 48
#define NROWMINF 1
#define NSECSPER 1
#define NROWSPER 32
#define SYNCHVAL 0xABB4
#define NROWMAJF 64
#define MFSECNUM 32
#define MFSECDEN 1
#define SECDRIFT 90
#define COPY_MFCtr
#define MFCtr home->U0.MFCtr

#ifndef EXTRACTION_INIT
  #define EXTRACTION_INIT
#endif
#ifndef OPT_EXT_INIT
  #define OPT_EXT_INIT
#endif
#ifndef EXTRACTION_TERM
  #define EXTRACTION_TERM
#endif
#ifndef TMINITFUNC
  #define TMINITFUNC
#endif

static unsigned int next_minor_frame, majf_row;
#if (NROWMINF != 1)
  static unsigned int minf_row = 0;
#endif
#ifdef NEED_TIME_FUNCS
  static unsigned short CurMFC;
#endif


void main(int argc, char **argv) {
  oui_init_options(argc, argv);

  TMINITFUNC;
  BEGIN_MSG;
  EXTRACTION_INIT;
  DC_operate();
  EXTRACTION_TERM;
  DONE_MSG;
}


#define MKDCTV(x,y) ((x<<8)|y)
#define DCTV(x,y) MKDCTV(DCT_##x,DCV_##y)

/* The main thing we need to do is reset our row counter on TM START */
void DC_DASCmd(unsigned char type, unsigned char val) {
  switch (MKDCTV(type, val)) {
	case DCTV(TM,TM_START):
	  next_minor_frame = majf_row = 0;
	  #if (NROWMINF != 1)
		minf_row = 0;
	  #endif
	  break;
	case DCTV(TM,TM_END):
	case DCTV(QUIT,QUIT):
	default:
	  break;
  }
}

#define incmod(x,y) if (x==((y)-1)) x = 0; else x++

void DC_data(dbr_data_type *dr_data) {
  unsigned short nrows;

  for (nrows = dr_data->n_rows, home = (void *) &dr_data->data[0];
	   nrows > 0;
	   nrows--, home ++) {

	/* First check the minor frame counter if necessary */
	#if (NROWMINF != 1)
	if (minf_row == 0) {
	#endif
	  COPY_MFCtr /* Needs to be defined by TMC */
	  #ifdef NEED_TIME_FUNCS
		CurMFC = MFCtr;
	  #endif
	  {
		unsigned short delta;
		
		delta = MFCtr - next_minor_frame;
		if (delta != 0) {
		  #ifdef IVFUNCS
			if (delta > NROWMAJF/NROWMINF) delta = NROWMAJF;
			else delta *= NROWMINF;
			/* delta is now the number of rows skipped up to a maximum of
			  nrowmajf. While invalidating, I don't need to update
			  minf_row, since the final will be 0, same as before.
			  MFCtr is already set, and majf_row is updated.
			*/
			while (delta-- > 0)
			  ivfuncs[majf_row]();
		  #endif
		  majf_row = (((unsigned short)MFCtr) % (NROWMAJF/NROWMINF))
							  * NROWMINF;
		}
	  }
	  next_minor_frame = MFCtr+1;
	#if (NROWMINF != 1)
	}
	#endif
	
	/* Now process the row */
	efuncs[majf_row]();
	incmod(majf_row, NROWMAJF);
	#if (NROWMINF != 1)
	  incmod(minf_row, NROWMINF);
	#endif
  }
}

#ifdef __WATCOMC__
  #pragma off (unreferenced)
#endif

void DC_tstamp(tstamp_type *tstamp) { /* Nothing to do! */ }

void DC_other(unsigned char *msg_ptr, int sent_tid) {
  unsigned char rep_msg = DAS_UNKN;

  Reply(sent_tid, &rep_msg, 1);
}

#ifdef __WATCOMC__
  #pragma on (unreferenced)
#endif

#ifdef NEED_TIME_FUNCS
  #if (NROWMINF != 1)
	#define ROWS(x) (((unsigned long)(x))*NROWMINF+minf_row)
  #else
	#define ROWS(x) (x)
  #endif
  #if (NSECSPER != 1)
	#define FRACSECS(x) (((unsigned long)ROWS(x))*NSECSPER)
  #else
	#define FRACSECS(x) ROWS(x)
  #endif
  long itime(void) {
	  return(dbr_info.t_stmp.secs +
		FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double dtime(void) {
	  return(dbr_info.t_stmp.secs +
		(double) FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double etime(void) {
	double t;
	static double t0 = -1e9;
	
	t = dtime();
	if (t0 == -1e9) t0 = t;
	return(t - t0);
  }
#endif

dbr_info_type dbr_info = {
  "", /* tmid */
  48, /* NBMINF */
  48, /* NBROW */
  64, /* NROWSMAJF */
  1, /* NSECSPER */
  32, /* NROWSPER */
  0, 1, /* MFC lsb col, msb col */
  0xABB4, /* Synch Value */
  0 /* not inverted */
};
