%{
#include <stdio.h>
#include <stdlib.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/proxy.h>
#include <string.h>
#include <math.h>
#include <i86.h>
#include <unistd.h>

#include "globmsg.h"
#include "nortlib.h"
#include "ttdriver.h"
#include "soldrv.h"
#include "regnames.h"
#include "address.h"
#include "defcals.h"

#include "valves.h"
#include "panthermsg.h"
#include "convfunc.h"
#include "elec.h"
#include "omega.h"
#include "msd.h"
#include "stop.h"
#include "dac.h"

#define IOMODE_INIT 	 27

int msd_enable = 0;
int GCrunmode;
int MSrunmode;

%}

&start
	: &commands Quit     	* { 
		SafeState( ); 
		cis_terminate();
	
		send_dascmd(DCT_QUIT, DCV_QUIT, 1);
		delay(2000);
	}

	: &commands Shutdown	* { 
		switch_ssv( 1, 1 ); delay(200);
		switch_ssv( 2, 1 ); delay(200);
		delay(100);

		shutdownservers();
		delay(100);

		cis_terminate();
	
		send_dascmd(DCT_QUIT, DCV_QUIT, 1);
		delay(4000);
		system("/usr/local/bin/shutdn");
	}
	: &commands &&Exit
	;
&&Exit
	: Exit * {
		switch_ssv( 1, 1 ); delay(200);
		switch_ssv( 2, 1 ); delay(100);

		//cis_terminate();
		send_dascmd(DCT_QUIT, DCV_QUIT, 1);
		delay(2000); 
	}
	;
&commands
	:
	: &commands &command
	;
&command
	: *
	: Log %s ( Enter String to Log to Memo ) * {}
	: Telemetry &tm_cmd
	: &&local
	;
&tm_cmd
	: Start * { send_dascmd(DCT_TM, DCV_TM_START, 1); }
	: Logging Suspend * { send_dascmd(DCT_TM, DCV_TM_SUSLOG, 1); }
	: Logging Resume * { send_dascmd(DCT_TM, DCV_TM_RESLOG, 1); }
	;
&&local
	: IOMODE %d (Backspace=1 Space=2 Always=4 Word=8 WordSkip=16) *
		{ iomode = $2; }
	;

&command
	: Flow &Flow_Chan Setpoint &Flow_SP *  { SetFlow( $2, $4 ); }

	: Press CO  Setpoint &Press_SP *    { SetPress( 2, $4, 0 ); }
	: Press SF6 Setpoint &Press_SP *    { SetPress( 5, $4, 0 ); }
	: Press F11 Setpoint &Press_SP *    { SetPress( 8, $4, 0 ); }
	: Press PAN 1 Setpoint &Press_SP *  { SetPress( 9, $5, 1 ); }
	: Press PAN 2 Setpoint &Press_SP *  { SetPress( 10, $5, 1 ); }
	: Press PAN SLoop Setpoint &Press_SP * { SetPress( 11, $5, 1 ); }
	: Press MS 1 Setpoint &Press_SP *   { SetPress( 12, $5, 1 ); }
	: Press MS 2 Setpoint &Press_SP *   { SetPress( 13, $5, 1 ); }

	: DAC Board &Safe *  { tt_dac_enbl( $3 ); }

	: Mode &ModeSet

	: scdc_cmd %d * { tt_scdc_command( $2 ); }

	: msd ionwin &ionwinc * { SwitchIonWin( $3 ); }
	: msd read ionfile * { ReadMSDionFileNow( "msd.ions" ); }
	: msd run * { sendMSDmessage( msg_msdStartRun ); }
	: msd stop * { sendMSDmessage( msg_msdStopRun ); }
	: msd duration %f * { sendMSDdata( msg_msdSetDuration, $3 ); }
	: msd filament number %d ( 1 or 2 ) * { sendMSDdata( msg_msdSetFilamentNum, $4 ); }
	: msd tune temp quad %f * { sendMSDdata( msg_msdSetQuadTemp, $5 ); }
	: msd tune temp source %f * { sendMSDdata( msg_msdSetSrcTemp, $5 ); }
	: msd tune source emission %f ( 0 to 314.2 uAmps ) * { sendMSDdata( msg_msdSetEmission, $5 ); }
	: msd tune source elecEng %f ( 0 to 241.5 Volts ) * { sendMSDdata( msg_msdSetElecEng, $5 ); }
	: msd tune source lens gain %f ( 0 to 242.0 Volts ) * { sendMSDdata( msg_msdSetLens, $6 ); }
	: msd tune source lens offset %f ( 0 to 64 ) * { sendMSDdata( msg_msdSetLensOffset, $6 ); }
	: msd tune source ionfocus %f ( 0 to 242.0 Volts ) * { sendMSDdata( msg_msdSetIonFocus, $5 ); }
	: msd tune source repeller %f ( -0.2 to 42.7 Volts ) * { sendMSDdata( msg_msdSetRepeller, $5 ); }
	: msd tune quad amu gain %f ( 0 to 4095 DAC counts ) * { sendMSDdata( msg_msdSetAmuGain, $6 ); }
	: msd tune quad amu offset %f ( 0 to 4095 DAC counts ) *  { sendMSDdata( msg_msdSetAmuOffset, $6 ); }
	: msd tune quad DCpol %f ( 0 or 1 ) * { sendMSDdata( msg_msdSetDCpol, $5 ); }
	: msd tune quad EMvolt %f ( 0 to 3000 Volts ) * { sendMSDdata( msg_msdSetEMvolt, $5 ); }
	: msd tune quad wid219 %f ( -0.15 to 0.15 ) * { sendMSDdata( msg_msdSetWid219, $5 ); }
	: msd tune quad mass gain %f ( -32768 to 32767 ) * { sendMSDdata( msg_msdSetMassGain, $6 ); }
	: msd tune quad mass offset %f ( -32768 to 32767 ) * { sendMSDdata( msg_msdSetMassOffset, $6 ); }
	: msd DoNothing * { }
	
	: PAN Lamp &On * { tt_scdc_command( 18 + $3 ); }
	: PAN Gas &On * { tt_scdc_command( 6 + $3 ); }
	: PAN Flow Controller &On * { tt_scdc_command( 19 + $4 ); }
	 
	: GSV F11 &GSVVALVEPOS 	{ switch_gsv( 3, $3 ); }
	: GSV F11 DoNothing 	{ }
	: GSV CO  &GSVVALVEPOS 	{ switch_gsv( 4, $3 ); }
	: GSV CO DoNothing 		{ }
	: GSV PAN &GSVVALVEPOS 	{ switch_gsv( 5, $3 ); }
	: GSV PAN DoNothing 	{ }
	: GSV SF6 &GSVVALVEPOS 	{ switch_gsv( 6, $3 ); }
	: GSV SF6 DoNothing 	{ }
	: GSV MS 8port Inj1 	{ switch_gsv( 7, 2 ); }
	: GSV MS 8port Inj2 	{ switch_gsv( 7, 1 ); }
	: GSV MS 6port Inj1 	{ switch_gsv( 8, 2 ); }
	: GSV MS 6port Inj2 	{ switch_gsv( 8, 1 ); }
	: GSV MS both Inj1 		{ switch_MSgsvs_both( 1 ); }
	: GSV MS both Inj2 		{ switch_MSgsvs_both( 2 ); }
	: GSV MS both DoNothing { }

	: SSV Table GC DoNothing * 					{ }
	: SSV Table MSD DoNothing * 				{ }
	: SSV Table PAN DoNothing * 				{ }
	: SSV Table GC IncTable * 					{ handlessvGC( 1, 1, GCrunmode ); }
	: SSV Table MSD IncTable * 					{ handlessvMS( 2, 1, MSrunmode ); }
	: SSV Table PAN IncTable * 					{ handlessvPAN( 9, 1, GCrunmode ); }
	: SSV Manual GC Position &SSVposition * 	{ switch_ssv( 1, $5 ); }
	: SSV Manual MSD Position &SSVposition * 	{ switch_ssv( 2, $5 ); }
	: SSV Manual PAN air * 						{ PANssvState( 1 ); }
	: SSV Manual PAN cal * 						{ PANssvState( 2 ); }

	: Elec Reset &elecnum * { elec_reset( $3 ); }
	: Elec Bias &elecnum &bias_change * { elec_bias( $3, $4 ); }
	
	: Omega ChangeSP1 &OMEGAaddress %f *  { setOmegaSP1( $3, $4 ); }
	: Omega ChangeSP1 DoNothing * { }
	: Omega Reset &OMEGAaddress *  { OmegaReset( $3 ); }
	: Omega MS_PAN 1MS column %f * { SetTrapTemp( 15, $5 ); }
	: Omega MS_PAN 2MS column %f * { SetTrapTemp( 14, $5 ); }

	: Pump &WhichPump &On * { tt_scdc_command( $2 + $3 ); }

	: Solenoid &WhichSol * { tt_scdc_command( $2 ); }
	: Solenoid Peltier Trap both &On * 
		{ tt_scdc_command( 16 + $5 ); tt_scdc_command( 17 + $5 );}
	: Solenoid Sample Loop GC both &Close * 
		{ tt_scdc_command( 0 + $6 ); tt_scdc_command( 2 + $6 ); }
	: Solenoid Sample Loop PAN both Close *
		{ tt_scdc_command( 5 ); tt_scdc_command( 107 ); }
	: Solenoid Sample Loop PAN both Open *
		{ tt_scdc_command( 105 ); tt_scdc_command( 7 ); }
	;

&GSVVALVEPOS <unsigned short>
	: Load { $0 = 1; }
	: Inject { $0 = 2; }
	;
&SSVposition <unsigned short>
	: %d (1 to 6) { 
		if ($1 < 1) 
			$0 = 1;
		else {
			if ($1 > 6) 
				$0 = 6;
			else
				$0 = $1;
		}
	}
	;

&ModeSET 
	: GC &GCModeName * { GCrunmode = $2; send_dascmd( DCT_SOLDRV_A, $2, -1 ); }
	: MSD &MSDModeName * { MSrunmode = $2; send_dascmd( DCT_SOLDRV_B, $2, -1 ); }
	;

&GCModeName <unsigned short>
	: Safe { $0 = 0; }
	: Init { $0 = 1; }
	: Run { $0 = 2; }
	: Lab 1 { $0 = 3; }
	: Lab 2 { $0 = 4; }
	: Cal { $0 = 7; }
	: Shutdown { $0 = 9; }
	;

&MSDModeName <unsigned short>
	: Safe { $0 = 0; }
	: Init { $0 = 1; }
	: Run { $0 = 2; }
	: Lab 1 { $0 = 3; }
#	: Lab 2 { $0 = 4; }
	: Cal { $0 = 7; }
	: Shutdown { $0 = 9; }
	;

&elecnum <unsigned short>
	: SF6 { $0 = 1; }
	: F11 { $0 = 2; }
	: CO  { $0 = 3; }
	: PAN { $0 = 4; }
	;

&OMEGAaddress <unsigned short>
	: F11 Col       		{ $0 = 1; }
	: CO Col        		{ $0 = 2; }
	: SF6 Col      			{ $0 = 3; }
	: SF6 Post      		{ $0 = 4; }
	: F11 ECD       		{ $0 = 5; }
	: CO ECD        		{ $0 = 6; }
	: SF6 ECD       		{ $0 = 7; }
	: MS Trap Cold Block 1	{ $0 = 8; }
	: MS Trap Cold Block 2	{ $0 = 9; }
	: PAN ECD       		{ $0 = 10; }
	;

&ionwinc <short>
	: next { $0 = -1; }
	: choose &ionwinchoice { $0 = $2; }
	;

&ionwinchoice <unsigned short>
	: %d (0 to 29) {
		if ($1 < 0) 
			$0 = 0;
		else if ($1 > 30) 
			$0 = 29;
		else
			$0 = $1;
	}
	;

&WhichPump <unsigned short>
	: Inlet { $0 = 15; }
	: MS Sample { $0 = 12; }
	: Turbo {$0 = 14; }
	;

&WhichSol <unsigned short>
	: Sample Loop GC In &Close	{ $0 = 0 + $5; }
	: PAN O2 flush &Close		{ $0 = 1 + $4; }
	: Sample Loop GC Out &Close { $0 = 2 + $5; }
	: Sample Loop MS Out &Open	{ $0 = 3 + $5; }
	: Sample Loop PAN In &Close	{ $0 = 5 + $5; }
	: Sample Loop PAN Out &Open	{ $0 = 7 + $5; }
	: PAN Sample Air			{ $0 = 4; }
	: PAN Sample Cal			{ $0 = 104; }
	: PAN Gas &On				{ $0 = 6 + $3; }
	: Peltier Trap 1 &On 		{ $0 = 16 + $4; }
	: Peltier Trap 2 &On 		{ $0 = 17 + $4; }
	: Trap 1 Heat &On		 	{ $0 = 20 + $4; }
	: Trap 2 Heat &On 			{ $0 = 21 + $4; }
	: Trap 1 Relay &On 			{ $0 = 22 + $4; }
	: Trap 2 Relay &On 			{ $0 = 23 + $4; }
	;

&bias_change <unsigned short>
	: %d (Enter bias Value 0-255)
	  { if ($1 < 0) $0 = 0;
		else if ($1 > 255) $0 = 255;
		else $0 = $1;
	  }
	;

&Hi <unsigned short>
	: Hi { $0 = 100; }
	: Low { $0 = 0; }
	;
&On <unsigned short>
	: On { $0 = 100; }
	: Off { $0 = 0; }
	;
&Open <unsigned short>
	: Close { $0 = 100; }
	: Open { $0 = 0; }
	;
&Close <unsigned short>
	: Close { $0 = 0; }
	: Open { $0 = 100; }
	;
&Safe <unsigned short>
	: Enable { $0 = 0; }
	: Safe { $0 = 1; }
	;
&BFClosed <unsigned short>
	: Closed { $0 = 100; }
	: Opened { $0 = 0; }
	;
&Flow_Chan <unsigned short>
	: CO main 	{ $0 = 0; }
	: CO bf		{ $0 = 1; }
	: SF6 main 	{ $0 = 3; }
	: SF6 bf 	{ $0 = 4; }
	: F11 main 	{ $0 = 6; }
	: F11 bf 	{ $0 = 7; }
	: PAN 1		{ $0 = 9; }
	: PAN 2		{ $0 = 10; }
	: MS 1 		{ $0 = 12; }
	: MS 2 		{ $0 = 13; }
	;
%{
/*----------------------------------------------------------------
  This approach to identifying the channels results in prompts
  for the available channels. Using %d would work also, but
  would allow the user to enter erroneous values (5, 6).
  On the other hand, this approach doesn't give access to the
  unused channels...
----------------------------------------------------------------*/
%}
&Cal_Num <unsigned short>
	: 3 { $0 = 3; }
	;
&Trap_Num <unsigned short>
	: 1 { $0 = 6; }
	: 2 { $0 = 7; }
	;
%{
/*----------------------------------------------------------------
  This Setpoint value is the digital value written to the device,
  not engineering units. If we wish to command the device with
  engineering units, additional calculations are required.
  Rather than complain bitterly about out-of-range values, I
  simply map outliers onto the extremes. Alternate approaches
  are possible also.
----------------------------------------------------------------*/
%}
&DAC_SP <unsigned short>
	: %d (Enter Setpoint Value 0-4095)
	  { if ($1 < 0) $0 = 0;
		else if ($1 > 4095) $0 = 4095;
		else $0 = $1;
	  }
	;
%{

/*----------------------------------------------------------------
 These routines are set for one calibration.  So if each flow controller
 has/needs a different calibration -- it'll need modifing.  GSD 
----------------------------------------------------------------*/
%}
&Flow_SP <float>
	: %f (Enter flow) { $0 = $1; }
	;
&Press_SP <float>
	: %f (Enter pressure) { $0 = $1; }
	;
